extensions [ gis profiler array] ;  Needed in order to acquire the GIS input data
                                 ;  Needed in order to acquire the Climatic input data

;Creation of classes as per UML Class Diagram
breed [Tourists Tourist]
breed [MEAs MEA]
breed [ReferencePoints ReferencePoint]
breed [Accomodations Accomodation]
breed [Restaurants Restaurant]
breed [Retailers Retailer]
breed [OtherFacilities OtherFacility]
breed [Down_hills Down_hill]
breed [OffPistes OffPiste]
breed [XCountries XCountry]
breed [SnowParks SnowPark]
breed [Zones Zone]
breed [ski-areas ski-area]
 
;Declaration of variables as per UML Class Diagrams

globals [season month avDestSnowCover avDestSnowSecurity historicMaxCover tickMax tickStar 
         
         CnVisitors nVisitors potentials nOvernightVisitors arrivals TotCumTransfer DailyTransfer indivDailyTransfer
         
         usTSI usSPT usSAX usSAW usCCP usCCW usEC usID usTOT
         deadTSI deadSPT deadSAX deadSAW deadCCP deadCCW deadEC deadID
         nTSI nSPT nSAX nSAW nCCP nCCW nEC nID 
         CnTSI CnSPT CnSAX CnSAW CnCCP CnCCW CnEC CnID 
         CUMavExpense avExpense avExpenseTSI avExpenseSPT avExpenseID avExpenseEC avExpenseSAX avExpenseSAW avExpenseCCW avExpenseCCP
         
         area-dataset rp-dataset lUse-dataset
         
         totNbeds1 totNbeds2 totNbeds3 newtotNbeds1 newtotNbeds2 newtotNbeds3 totNbeds newtotNbeds
         totNcovers1 totNcovers2 totNcovers3 newtotNcovers1 newtotNcovers2 newtotNcovers3 newtotNcovers totNcovers  
         totm2ret1 totm2ret2 totm2ret3 totm2ret4 newtotm2ret1 newtotm2ret2 newtotm2ret3 newtotm2ret4 newtotm2ret totm2ret
         totCCCof1 totCCCof2 totCCCof3 newtotCCCof1 newtotCCCof2 newtotCCCof3 newtotCCCof totCCCof
         totKM2dh newtotKM2dh 
         totKmXC newtotKmXC totkmss newtotkmss
         totliftsOP newtotliftsOP
         newtotliftsSP newtotkm2SP
         
         totartsnowcost totartsnowcostSP totartsnowcostXC totartsnowcostDH totcumartsnowcost  
         
         nature-ratio km-downhill km-offpiste km-freeride km-xcountry tricks-sp 
         boutique-ratio nwellness nkindergarten nothersport nqualityhotels
         cc-wellness cc-kindergarten beds-qualityhotels cc-othersport h i kmartsnowDH kmartsnowXC kmartsnowSP
         
         counter xx mean-gsize nagents
         
         ;climate data to array
         temp_800 cover_800 temp_1000 cover_1000 temp_1100 cover_1100 temp_1200 cover_1200
         temp_1400 cover_1400 temp_1500 cover_1500 temp_1600 cover_1600 temp_1700 cover_1700
         temp_1800 cover_1800 temp_2600 cover_2600
         
         ;BEHAVIOURAL PARAMETERS to test
         gsize-mean-TSI gsize-sd-TSI stay-mean-TSI stay-sd-TSI pos=0-TSI  km-threshold-mean-TSI  km-threshold-sd-TSI 
         snow-threshold-mean-TSI snow-threshold-sd-TSI kids-prob-mean-TSI kids-prob-sd-TSI snow-shoes-prob-mean-TSI 
         snow-shoes-prob-sd-TSI prop-factor-conservative-TSI comp-factor-generic-TSI prop-factor-optimistic-TSI comp-factor-niche-TSI

         gsize-mean-SPT gsize-sd-SPT stay-mean-SPT stay-sd-SPT pos=0-SPT km-threshold-mean-SPT  km-threshold-sd-SPT  
         nature-threshold-mean-SPT nature-threshold-sd-SPT snow-threshold-mean-SPT snow-threshold-sd-SPT kids-prob-mean-SPT 
         kids-prob-sd-SPT snow-shoes-prob-mean-SPT snow-shoes-prob-sd-SPT prop-factor-conservative-SPT comp-factor-generic-SPT 
         prop-factor-optimistic-SPT comp-factor-niche-SPT

         gsize-mean-ID gsize-sd-ID stay-mean-ID stay-sd-ID pos=0-ID nature-threshold-mean-ID nature-threshold-sd-ID snow-threshold-mean-ID 
         snow-threshold-sd-ID kids-prob-mean-ID kids-prob-sd-ID snow-shoes-prob-mean-ID snow-shoes-prob-sd-ID wellness-threshold-mean-ID 
         wellness-threshold-sd-ID kids-threshold-mean-ID kids-threshold-sd-ID prop-factor-conservative-ID comp-factor-generic-ID 
         prop-factor-optimistic-ID comp-factor-niche-ID

         gsize-mean-EC gsize-sd-EC stay-mean-EC stay-sd-EC pos=0-EC snow-threshold-mean-EC snow-threshold-sd-EC kids-prob-mean-EC 
         kids-prob-sd-EC snow-shoes-prob-mean-EC snow-shoes-prob-sd-EC wellness-threshold-mean-EC wellness-threshold-sd-EC 
         sports-threshold-mean-EC sports-threshold-sd-EC qualityhotels-threshold-mean-EC qualityhotels-threshold-sd-EC boutiques-threshold-mean-EC 
         boutiques-threshold-sd-EC prop-factor-conservative-EC comp-factor-generic-EC prop-factor-optimistic-EC comp-factor-niche-EC

         gsize-mean-SAX gsize-sd-SAX stay-mean-SAX stay-sd-SAX pos=0-SAX km-threshold-mean-SAX km-threshold-sd-SAX  nature-threshold-mean-SAX 
         nature-threshold-sd-SAX snow-threshold-mean-SAX snow-threshold-sd-SAX kids-prob-mean-SAX kids-prob-sd-SAX snow-shoes-prob-mean-SAX 
         snow-shoes-prob-sd-SAX prop-factor-conservative-SAX comp-factor-generic-SAX prop-factor-optimistic-SAX comp-factor-niche-SAX

         gsize-mean-SAW gsize-sd-SAW stay-mean-SAW stay-sd-SAW pos=0-SAW km-threshold-mean-SAW km-threshold-sd-SAW nature-threshold-mean-SAW 
         nature-threshold-sd-SAW snow-threshold-mean-SAW snow-threshold-sd-SAW kids-prob-mean-SAW kids-prob-sd-SAW snow-shoes-prob-mean-SAW 
         snow-shoes-prob-sd-SAW prop-factor-conservative-SAW comp-factor-generic-SAW prop-factor-optimistic-SAW comp-factor-niche-SAW

         gsize-mean-CCW gsize-sd-CCW stay-mean-CCW stay-sd-CCW pos=0-CCW km-threshold-mean-CCW km-threshold-sd-CCW nature-threshold-mean-CCW 
         nature-threshold-sd-CCW snow-threshold-mean-CCW snow-threshold-sd-CCW kids-prob-mean-CCW kids-prob-sd-CCW snow-shoes-prob-mean-CCW
         snow-shoes-prob-sd-CCW prop-factor-conservative-CCW comp-factor-generic-CCW prop-factor-optimistic-CCW comp-factor-niche-CCW

         gsize-mean-CCP gsize-sd-CCP stay-mean-CCP stay-sd-CCP pos=0-CCP snow-threshold-mean-CCP snow-threshold-sd-CCP kids-prob-mean-CCP 
         kids-prob-sd-CCP snow-shoes-prob-mean-CCP snow-shoes-prob-sd-CCP tricks-threshold-mean-CCP tricks-threshold-sd-CCP prop-factor-conservative-CCP
         comp-factor-generic-CCP prop-factor-optimistic-CCP comp-factor-niche-CCP
         
         Vlist VarCo sigma mu]

patches-own [area lUse reference-point occupation avOcc id cover]

Tourists-own [category destination planning potential gSize stay busy satisfaction kids-prob kids snow-shoes-prob snow-shoes 
              creation dest-counter comp prop-factor expense own-daily-transfer myzone
               
              myDownHill myXCountry myOffPiste mySnowPark myOtherSport myKidsFacility
              myWellness myBar myFood myClothes mySouvenirs myRestaurant myAccomodation
               
              KM-threshold Nature-threshold tricks-threshold kids-threshold wellness-threshold
              sports-threshold qualityhotels-threshold boutiques-threshold snow-threshold]

MEAs-own [category avFixedCostUnit totalInvestment return balance seabalance avVarCostUnit avPrice hlabour energy]    

ReferencePoints-own [myzone myPatch yTemp Temp SnowCover fSnowCover SnowSecurity alt-range]

Accomodations-own [myzone myarea myPatch Category nBeds users occupation-rate price]  

Restaurants-own [myzone myPatch Category nCovers users occupation-rate price]

Retailers-own [myzone myPatch Category users m2 price]

OtherFacilities-own [myzone myPatch Category users  CCC m2 occupation-rate price]

Down_hills-own [myzone myname myPatches kmTracks nLifts users density occupation-rate avSnowCover artSnowCost cumArtSnowCost natsnowday snow0-10 snow10-20 snow20-30
                CCC Km2 AS maxTemp artSnowDay price] 

OffPistes-own [myzone myName myPatches kmTracks nLifts users density occupation-rate avSnowCover fAvSnowCover CCC price]

XCountries-own [myzone myname myPatches kmTracks users density occupation-rate avSnowCover fAvSnowCover CCC snowshoes natsnowday
                AS artSnowCost maxTemp cumArtSnowCost artSnowDay price] 

SnowParks-own [myzone myPatches nLifts ntricks km2 users density occupation-rate avSnowCover artSnowCost CCC AS maxTemp natsnowday
               cumArtSnowCost artSnowDay price] 

zones-own [myname mypatches myreferencepoints avZoneSnowCover fAvZoneSnowCover maxZoneTemp
           mydownhills myxcountries myOffPistes mySnowParks myOtherSports myKidsFacilities
           mywellnesses myBars myFoods myClothes mySouvenirs myRestaurants myAccomodations ]

ski-areas-own [myname mydownhills myoffpistes kmdownhills kmOffPistes free-ride] 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Initialization
to setup 
 ;; (for this model to work with NetLogo's new plotting features,
  ;; __clear-all-and-reset-ticks should be replaced with clear-all at
  ;; the beginning of your setup procedure and reset-ticks at the end
  ;; of the procedure.)
  __clear-all-and-reset-ticks 
 ;set globals 0
 set season 0
 set avDestSnowCover 0 set avDestSnowSecurity 0 set historicMaxCover 30 set tickMax 31 set tickStar 31 
 set nVisitors 0
 set deadTSI 0  set deadSPT 0 set deadSAX 0 set deadSAW 0 set deadCCW 0 set deadCCP 0 set deadID 0 set deadEC 0
 set Vlist []
 
 ask patches [ set occupation 0 set id 0 set area "nil" set cover "nil"]

 ;climate data input
 get-climate-data
 
 ;GIS INPUT 
 get-gis-data

 ;Visualization of the map
 visualize-land
 
 ;Set parameters of tourists
 get-behavioural-parameters
 
 ;Creation of turtles as per BAU strategy and Initialization of turtles
 ;Creation of tourist according to societal scenario
 init-tourists
 
 ;Creation of MetaEconomicAgents
 init-MEAs
 
 ;Creation of Accomodations and their spatial distribution
 init-Accomodations
 
 ;Creation of Restaurants and their spatial distribution
 init-Restaurants
 
 ;Creation of Retailers and their spatial distribution
 init-Retailers
 
 ;Creation of OtherFacilities and their spatial distribution
 init-OtherFacilities
 
 ;Creation of Downhill facilities and their spatial distribution
 init-Down_Hills
 
 ;Creation of Xcountry facilities and their spatial distribution
 init-XCountries
 
 ;Creation of OffPistes facilities and their spatial distribution
 init-Offpistes
 
 ;Creation of ReferencePoints and their spatial distribution
 init-ReferencePoints
 
 ;Creation of zones and their spatial distribution
 init-zones
 
 ;Creation of ski-areas
 init-ski-areas
 
 checkDestination
 checkDestinationParameters
end
 
 to get-climate-data
 
 read-climate-data-800
 read-climate-data-1000
 read-climate-data-1100
 read-climate-data-1200
 read-climate-data-1400
 read-climate-data-1500
 read-climate-data-1600
 read-climate-data-1700
 read-climate-data-1800
 read-climate-data-2600   
     
 end


 to read-climate-data-800 
   set temp_800 array:from-list n-values 5040 [0]
   set cover_800 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_800.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_800.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_800.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_800.csv"]
   while [not file-at-end?] 
   [array:set temp_800 counter file-read
   array:set cover_800 counter file-read
   set counter counter + 1]
   file-close 
 end
 
to read-climate-data-1000 
   set temp_1000 array:from-list n-values 5040 [0]
   set cover_1000 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1000.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1000.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1000.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1000.csv"]
   while [not file-at-end?] 
   [array:set temp_1000 counter file-read
   array:set cover_1000 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1100 
   set temp_1100 array:from-list n-values 5040 [0]
   set cover_1100 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1100.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1100.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1100.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1100.csv"]
   while [not file-at-end?] 
   [array:set temp_1100 counter file-read
   array:set cover_1100 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1200 
   set temp_1200 array:from-list n-values 5040 [0]
   set cover_1200 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1200.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1200.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1200.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1200.csv"]
   while [not file-at-end?] 
   [array:set temp_1200 counter file-read
   array:set cover_1200 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1400 
   set temp_1400 array:from-list n-values 5040 [0]
   set cover_1400 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1400.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1400.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1400.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1400.csv"]
   while [not file-at-end?] 
   [array:set temp_1400 counter file-read
   array:set cover_1400 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1500 
   set temp_1500 array:from-list n-values 5040 [0]
   set cover_1500 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1500.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1500.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1500.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1500.csv"]
   while [not file-at-end?] 
   [array:set temp_1500 counter file-read
   array:set cover_1500 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1600 
   set temp_1600 array:from-list n-values 5040 [0]
   set cover_1600 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1600.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1600.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1600.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1600.csv"]
   while [not file-at-end?] 
   [array:set temp_1600 counter file-read
   array:set cover_1600 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1700 
   set temp_1700 array:from-list n-values 5040 [0]
   set cover_1700 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1700.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1700.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1700.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1700.csv"]
   while [not file-at-end?] 
   [array:set temp_1700 counter file-read
   array:set cover_1700 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-1800 
   set temp_1800 array:from-list n-values 5040 [0]
   set cover_1800 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_1800.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_1800.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_1800.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_1800.csv"]
   while [not file-at-end?] 
   [array:set temp_1800 counter file-read
   array:set cover_1800 counter file-read
   set counter counter + 1]
   file-close 
 end

to read-climate-data-2600 
   set temp_2600 array:from-list n-values 5040 [0]
   set cover_2600 array:from-list n-values 5040 [0]
   set counter 0
   if ClimateScenario = "Remo-UBA A1B" [file-open "remo A1b project_2600.csv"]
   if ClimateScenario = "Remo-UBA B1" [file-open "remo B1 project_2600.csv"]
   if ClimateScenario = "Baseline80-00" [file-open "baseline80-00_2600.csv"]
   if ClimateScenario = "Baseline80-00x2" [file-open "baseline80-00x2_2600.csv"]
   while [not file-at-end?] 
   [array:set temp_2600 counter file-read
   array:set cover_2600 counter file-read
   set counter counter + 1]
   file-close 
 end

 to get-gis-data
    
 set area-dataset gis:load-dataset "11aree_modN.asc"
 set lUse-dataset gis:load-dataset "3lUse_modN.asc"
 set rp-dataset   gis:load-dataset "reference_pointsN.asc" 

 gis:apply-raster area-dataset area
 gis:apply-raster lUse-dataset lUse
 gis:apply-raster rp-dataset reference-point
 
 end
 
 to get-behavioural-parameters
   
   if param-settings = "calibrated"  [file-open "calibrated.csv"]
   
   if param-settings = "gsize-lower"  [file-open "min-1.csv"]
   if param-settings = "gsize-higher" [file-open "max-1.csv"]
   if param-settings = "stay-lower"  [file-open "min-2.csv"]
   if param-settings = "stay-higher"  [file-open "max-2.csv"]
   if param-settings = "pos=0-lower"  [file-open "min-3.csv"]
   if param-settings = "pos=0-higher" [file-open "max-3.csv"]
   if param-settings = "km-lower"    [file-open "min-4.csv"]
   if param-settings = "km-higher"   [file-open "max-4.csv"]
   if param-settings = "snow-lower"   [file-open "min-5.csv"]
   if param-settings = "snow-higher"  [file-open "max-5.csv"]
   if param-settings = "kidsp-lower"  [file-open "min-6.csv"]
   if param-settings = "kidsp-higher" [file-open "max-6.csv"]
   if param-settings = "ssp-lower"  [file-open "min-7.csv"]
   if param-settings = "ssp-higher" [file-open "max-7.csv"]
   if param-settings = "comp-lower"  [file-open "max-8.csv"]
   if param-settings = "comp-higher"  [file-open "min-8.csv"]
   
   if param-settings = "nature-lower"  [file-open "min-9.csv"]
   if param-settings = "nature-higher"  [file-open "max-9.csv"]
   
   if param-settings = "gn-kx-nx-clow" [file-open "gn-kx-nx-clow.csv"]
   if param-settings = "gn-kn-nx-clow" [file-open "gn-kn-nx-clow.csv"]
   if param-settings = "gn-kx-nn-clow" [file-open "gn-kx-nn-clow.csv"]
   if param-settings = "gn-kx-nx-chigh" [file-open "gn-kx-nx-chigh.csv"]
   if param-settings = "gn-kn-nn-clow" [file-open "gn-kn-nn-clow.csv"]
   if param-settings = "gn-kn-nx-chigh" [file-open "gn-kn-nx-chigh.csv"]
   if param-settings = "gn-kx-nn-chigh" [file-open "gn-kx-nn-chigh.csv"]
   if param-settings = "gn-kn-nn-chigh" [file-open "gn-kn-nn-chigh.csv"]
   
   if param-settings = "gx-kx-nx-clow" [file-open "gx-kx-nx-clow.csv"]
   if param-settings = "gx-kn-nx-clow" [file-open "gx-kn-nx-clow.csv"]
   if param-settings = "gx-kx-nn-clow" [file-open "gx-kx-nn-clow.csv"]
   if param-settings = "gx-kx-nx-chigh" [file-open "gx-kx-nx-chigh.csv"]
   if param-settings = "gx-kn-nn-clow" [file-open "gx-kn-nn-clow.csv"]
   if param-settings = "gx-kn-nx-chigh" [file-open "gx-kn-nx-chigh.csv"]
   if param-settings = "gx-kx-nn-chigh" [file-open "gx-kx-nn-chigh.csv"]
   if param-settings = "gx-kn-nn-chigh" [file-open "gx-kn-nn-chigh.csv"]
   
   while [not file-at-end?] 
   [ 
     set  gsize-mean-TSI  file-read set  gsize-sd-TSI  file-read set  stay-mean-TSI  file-read
     set  stay-sd-TSI  file-read set  pos=0-TSI   file-read set  km-threshold-mean-TSI   file-read
     set  km-threshold-sd-TSI   file-read set  snow-threshold-mean-TSI  file-read set  snow-threshold-sd-TSI  file-read
     set  kids-prob-mean-TSI  file-read set  kids-prob-sd-TSI  file-read set  snow-shoes-prob-mean-TSI  file-read 
     set  snow-shoes-prob-sd-TSI  file-read set  prop-factor-conservative-TSI  file-read set  comp-factor-generic-TSI  file-read
     set  prop-factor-optimistic-TSI  file-read set  comp-factor-niche-TSI  file-read set  gsize-mean-SPT  file-read 
     set  gsize-sd-SPT  file-read set  stay-mean-SPT  file-read set  stay-sd-SPT  file-read set  pos=0-SPT  file-read 
     set  km-threshold-mean-SPT   file-read set  km-threshold-sd-SPT   file-read set  nature-threshold-mean-SPT  file-read 
     set  nature-threshold-sd-SPT  file-read set  snow-threshold-mean-SPT  file-read set  snow-threshold-sd-SPT  file-read
     set  kids-prob-mean-SPT  file-read set  kids-prob-sd-SPT  file-read set  snow-shoes-prob-mean-SPT  file-read 
     set  snow-shoes-prob-sd-SPT  file-read set  prop-factor-conservative-SPT  file-read set  comp-factor-generic-SPT  file-read
     set  prop-factor-optimistic-SPT  file-read set  comp-factor-niche-SPT  file-read set  gsize-mean-ID  file-read
     set  gsize-sd-ID  file-read set  stay-mean-ID  file-read set  stay-sd-ID  file-read set  pos=0-ID  file-read 
     set  nature-threshold-mean-ID  file-read set  nature-threshold-sd-ID  file-read set  snow-threshold-mean-ID  file-read 
     set  snow-threshold-sd-ID  file-read set  kids-prob-mean-ID  file-read set  kids-prob-sd-ID  file-read 
     set  snow-shoes-prob-mean-ID  file-read set  snow-shoes-prob-sd-ID  file-read set  wellness-threshold-mean-ID  file-read
     set  wellness-threshold-sd-ID  file-read set  kids-threshold-mean-ID  file-read set  kids-threshold-sd-ID  file-read
     set  prop-factor-conservative-ID  file-read set  comp-factor-generic-ID  file-read set  prop-factor-optimistic-ID  file-read
     set  comp-factor-niche-ID  file-read set  gsize-mean-EC  file-read set  gsize-sd-EC  file-read set  stay-mean-EC  file-read 
     set  stay-sd-EC  file-read set  pos=0-EC  file-read set  snow-threshold-mean-EC  file-read set  snow-threshold-sd-EC  file-read 
     set  kids-prob-mean-EC  file-read set  kids-prob-sd-EC  file-read set  snow-shoes-prob-mean-EC  file-read set  snow-shoes-prob-sd-EC  file-read
     set  wellness-threshold-mean-EC  file-read set  wellness-threshold-sd-EC  file-read set  sports-threshold-mean-EC  file-read
     set  sports-threshold-sd-EC  file-read set  qualityhotels-threshold-mean-EC  file-read set  qualityhotels-threshold-sd-EC  file-read
     set  boutiques-threshold-mean-EC  file-read set  boutiques-threshold-sd-EC  file-read set  prop-factor-conservative-EC  file-read
     set  comp-factor-generic-EC  file-read set  prop-factor-optimistic-EC  file-read set  comp-factor-niche-EC  file-read
     set  gsize-mean-SAX  file-read set  gsize-sd-SAX  file-read set  stay-mean-SAX  file-read
     set  stay-sd-SAX  file-read set  pos=0-SAX  file-read set  km-threshold-mean-SAX  file-read set  km-threshold-sd-SAX   file-read
     set  nature-threshold-mean-SAX  file-read set  nature-threshold-sd-SAX  file-read set  snow-threshold-mean-SAX  file-read
     set  snow-threshold-sd-SAX  file-read set  kids-prob-mean-SAX  file-read set  kids-prob-sd-SAX  file-read
     set  snow-shoes-prob-mean-SAX  file-read set  snow-shoes-prob-sd-SAX  file-read set  prop-factor-conservative-SAX  file-read
     set  comp-factor-generic-SAX  file-read set  prop-factor-optimistic-SAX  file-read set  comp-factor-niche-SAX  file-read
     set  gsize-mean-SAW  file-read set  gsize-sd-SAW  file-read set  stay-mean-SAW  file-read set  stay-sd-SAW  file-read 
     set  pos=0-SAW  file-read set  km-threshold-mean-SAW  file-read set  km-threshold-sd-SAW  file-read set  nature-threshold-mean-SAW  file-read
     set  nature-threshold-sd-SAW  file-read set  snow-threshold-mean-SAW  file-read set  snow-threshold-sd-SAW  file-read set  kids-prob-mean-SAW  file-read
     set  kids-prob-sd-SAW  file-read set  snow-shoes-prob-mean-SAW  file-read set  snow-shoes-prob-sd-SAW  file-read set  prop-factor-conservative-SAW  file-read
     set  comp-factor-generic-SAW  file-read set  prop-factor-optimistic-SAW  file-read set  comp-factor-niche-SAW  file-read
     set  gsize-mean-CCW  file-read set  gsize-sd-CCW  file-read set  stay-mean-CCW  file-read set  stay-sd-CCW  file-read
     set  pos=0-CCW  file-read set  km-threshold-mean-CCW  file-read set  km-threshold-sd-CCW  file-read set  nature-threshold-mean-CCW  file-read
     set  nature-threshold-sd-CCW  file-read set  snow-threshold-mean-CCW  file-read set  snow-threshold-sd-CCW  file-read set  kids-prob-mean-CCW  file-read
     set  kids-prob-sd-CCW  file-read set  snow-shoes-prob-mean-CCW  file-read set  snow-shoes-prob-sd-CCW  file-read set  prop-factor-conservative-CCW  file-read
     set  comp-factor-generic-CCW  file-read set  prop-factor-optimistic-CCW  file-read set  comp-factor-niche-CCW  file-read set  gsize-mean-CCP  file-read
     set  gsize-sd-CCP  file-read set  stay-mean-CCP  file-read set  stay-sd-CCP  file-read set  pos=0-CCP  file-read set  snow-threshold-mean-CCP  file-read 
     set  snow-threshold-sd-CCP  file-read set  kids-prob-mean-CCP  file-read set  kids-prob-sd-CCP  file-read set  snow-shoes-prob-mean-CCP  file-read 
     set snow-shoes-prob-sd-CCP  file-read set  tricks-threshold-mean-CCP  file-read set  tricks-threshold-sd-CCP  file-read set  prop-factor-conservative-CCP  file-read
     set  comp-factor-generic-CCP  file-read set  prop-factor-optimistic-CCP  file-read set  comp-factor-niche-CCP  file-read
   ]
   file-close  
 end  
 
 to init-tourists
 ifelse ClimateScenario != "Baseline80-00"  
  ;all but baseline 
 [create-tourists 11250] 
 [create-tourists 5800] 
 
 ask tourists [set hidden? true set creation 0 set dest-counter 0
               ;set size 0.2 set color black
               set category "nil"  set busy "no" set gsize 0 set kids "no"  set potential "no" set destination "no" set planning 0 set stay 0 set satisfaction 0
               set  myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0
               set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0 set myAccomodation 0]
                                       
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "TSI" 
   set KM-threshold random-normal KM-threshold-mean-TSI KM-threshold-sd-TSI
   set kids-prob random-normal kids-prob-mean-TSI kids-prob-sd-TSI
   set snow-shoes-prob random-normal snow-shoes-prob-mean-TSI snow-shoes-prob-sd-TSI
   set snow-threshold random-normal snow-threshold-mean-TSI snow-threshold-sd-TSI] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "SPT" 
   set KM-threshold random-normal  KM-threshold-mean-SPT KM-threshold-sd-SPT
   set Nature-threshold  random-normal Nature-threshold-mean-SPT Nature-threshold-sd-SPT
   set kids-prob random-normal kids-prob-mean-SPT kids-prob-sd-SPT
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SPT snow-shoes-prob-sd-SPT
   set snow-threshold random-normal snow-threshold-mean-SPT snow-threshold-sd-SPT] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [
   set category "SAW" 
   set KM-threshold random-normal KM-threshold-mean-SAW KM-threshold-sd-SAW 
   set Nature-threshold  random-normal Nature-threshold-mean-SAW Nature-threshold-sd-SAW
   set kids-prob random-normal kids-prob-mean-SAW kids-prob-sd-SAW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAW snow-shoes-prob-sd-SAW
   set snow-threshold random-normal snow-threshold-mean-SAW snow-threshold-sd-SAW] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "SAX" 
   set KM-threshold random-normal KM-threshold-mean-SAX KM-threshold-sd-SAX  
   set Nature-threshold random-normal Nature-threshold-mean-SAX Nature-threshold-sd-SAX
   set kids-prob  random-normal kids-prob-mean-SAX kids-prob-sd-SAX 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAX snow-shoes-prob-sd-SAX
   set snow-threshold random-normal snow-threshold-mean-SAX snow-threshold-sd-SAX] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "ID"  
   set Nature-threshold  random-normal Nature-threshold-mean-ID Nature-threshold-sd-ID
   set kids-threshold random-normal kids-threshold-mean-ID kids-threshold-sd-ID 
   set wellness-threshold random-normal wellness-threshold-mean-ID wellness-threshold-sd-ID
   set kids-prob  random-normal kids-prob-mean-ID kids-prob-sd-ID  
   set snow-shoes-prob random-normal snow-shoes-prob-mean-ID snow-shoes-prob-sd-ID
   set snow-threshold random-normal snow-threshold-mean-ID snow-threshold-sd-ID] 
                                                                                                                                          
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "EC"  
   set sports-threshold random-normal sports-threshold-mean-EC sports-threshold-sd-EC
   set wellness-threshold random-normal  wellness-threshold-mean-EC wellness-threshold-sd-EC
   set qualityhotels-threshold random-normal qualityhotels-threshold-mean-EC qualityhotels-threshold-sd-EC
   set boutiques-threshold random-normal boutiques-threshold-mean-EC boutiques-threshold-sd-EC
   set kids-prob  random-normal kids-prob-mean-EC kids-prob-sd-EC 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-EC snow-shoes-prob-sd-EC
   set snow-threshold random-normal snow-threshold-mean-EC snow-threshold-sd-EC] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "CCW" 
   set KM-threshold random-normal KM-threshold-mean-CCW KM-threshold-sd-CCW 
   set Nature-threshold  random-normal Nature-threshold-mean-CCW Nature-threshold-sd-CCW
   set kids-prob  random-normal kids-prob-mean-CCW kids-prob-sd-CCW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCW snow-shoes-prob-sd-CCW
   set snow-threshold random-normal snow-threshold-mean-CCW snow-threshold-sd-CCW] 
 
 ask n-of int (0.125 * count tourists) tourists  with [ category = "nil" ]  [ 
   set category "CCP" 
   set tricks-threshold random-normal tricks-threshold-mean-CCP tricks-threshold-sd-CCP 
   set kids-prob random-normal kids-prob-mean-CCP kids-prob-sd-CCP 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCP snow-shoes-prob-sd-CCP
   set snow-threshold random-normal snow-threshold-mean-CCP snow-threshold-sd-CCP] 

 ask tourists with [category = "nil"] [die]
 
 ask tourists [ifelse (random-float 1 < kids-prob) [set kids "yes"] [set kids "no"]
 ifelse (random-float 1 < snow-shoes-prob) [set snow-shoes "yes"] [set snow-shoes "no"]] 
 
 set-comp&prop-factor
 
 end
 
 to set-comp&prop-factor

ask tourists with [category = "TSI"] 
[ 
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-TSI]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-TSI]  
if competition = "generic" [set comp comp-factor-generic-TSI]
if competition = "niche" [set comp comp-factor-niche-TSI]
]

ask tourists with [category = "SPT"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-SPT]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-SPT]  
if competition = "generic" [set comp comp-factor-generic-SPT]
if competition = "niche" [set comp comp-factor-niche-SPT]
]

ask tourists with [category = "ID"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-ID]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-ID]   
if competition = "generic" [set comp comp-factor-generic-ID]
if competition = "niche" [set comp comp-factor-niche-ID]
]  

ask tourists with [category = "EC"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-EC]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-EC]    
if competition = "generic" [set comp comp-factor-generic-EC]
if competition = "niche" [set comp comp-factor-niche-EC]
]  

ask tourists with [category = "SAX"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-SAX]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-SAX]     
if competition = "generic" [set comp comp-factor-generic-SAX]
if competition = "niche" [set comp comp-factor-niche-SAX]
]

ask tourists with [category = "SAW"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-SAW]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-SAW] 
if competition = "generic" [set comp comp-factor-generic-SAW]
if competition = "niche" [set comp comp-factor-niche-SAW]
]

ask tourists with [category = "CCP"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-CCP]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-CCP]  
if competition = "generic" [set comp comp-factor-generic-CCP]
if competition = "niche" [set comp comp-factor-niche-CCP]
]

ask tourists with [category = "CCW"] 
[
if SocietalScenario = "Conservative" [set prop-factor prop-factor-conservative-CCW]
if SocietalScenario = "Optimistic" [set prop-factor prop-factor-optimistic-CCW]   
if competition = "generic" [set comp comp-factor-generic-CCW]
if competition = "niche" [set comp comp-factor-niche-CCW]
]
end  
 
 to init-MEAs
 create-MEAs 8 [ set category "nil"  set avFixedCostunit 0 set totalInvestment 0 set return 0 set balance 0 set seabalance 0
                 set avVarCostUnit 0 set avPrice 0]  ;set size 0.2 set color black]

  ask one-of MEAs with [category = "nil"] [set category "accomodations"]
  ask one-of MEAs with [category = "nil"] [set category "restaurants"]
  ask one-of MEAs with [category = "nil"] [set category "retailers"]
  ask one-of MEAs with [category = "nil"] [set category "otherfacilities"]
  ask one-of MEAs with [category = "nil"] [set category "downhills"]
  ask one-of MEAs with [category = "nil"] [set category "offpistes"]
  ask one-of MEAs with [category = "nil"] [set category "xcountries"]  
  ask one-of MEAs with [category = "nil"] [set category "snowparks"] 
  
  ask MEAS [set hidden? true]                
 end
 
 to init-Accomodations
 create-accomodations 432 [ set category "nil" set mypatch patch  0 0   set color red set size 0.2 ]
 
 ask n-of 384 accomodations with [category = "nil"] [set category "extrahotels" set price 22]  ;extrahotel beds
                                                      
 ask n-of 325 accomodations with [category = "extrahotels"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                             set nBeds 10 ]
 ask n-of 3 accomodations with [category = "extrahotels" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                   set nBeds 50] 
 ask n-of 6 accomodations with [category = "extrahotels" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                   set nBeds 100]
 ask n-of 50 accomodations with [category = "extrahotels" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                    set nBeds 10]
 
  
 ask n-of 35 accomodations with [category = "nil"] [set category "one-two-stars" set price 30]  ;1-2 stars beds
                                                    
 ask n-of 25 accomodations with [category = "one-two-stars"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                             set nBeds 25]
 ask n-of 6 accomodations with [category = "one-two-stars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                     set nBeds 20]
 ask n-of 4 accomodations with [category = "one-two-stars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                     set nBeds 25]
 
 
 ask n-of 13 accomodations with [category = "nil"] [set category "three-four-stars" set price 43]  ;3-4 star beds
                                                    
 ask n-of 10 accomodations with [category = "three-four-stars"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                                 set nBeds 60]
 ask n-of 3 accomodations with [category = "three-four-stars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                        set nBeds 80]

 ask accomodations [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                     set myzone ([area] of mypatch)]
 
 set totNbeds1 sum [nbeds] of Accomodations with [category = "extrahotels"]
 set totNbeds2 sum [nbeds] of Accomodations with [category = "one-two-stars"]
 set totNbeds3 sum [nbeds] of Accomodations with [category = "three-four-stars"]
 end
 
 
 to init-Restaurants
 create-restaurants 46 [ set category "nil" set mypatch patch 0 0   set color orange set size 0.2]
 
 ask n-of 17 restaurants with [category = "nil"] [set category "low-cost" set price 15]
 
 ask n-of 10 restaurants with [category = "low-cost"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                       set nCovers 45]
 ask n-of 2 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                              set nCovers 50]
 ask n-of 3 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                              set nCovers 50]
 ask one-of restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 5 and lUse = 2]
                                                                              set nCovers 50]
 ask one-of restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]
                                                                              set nCovers 50]
 
 ask n-of 26 restaurants with [category = "nil"] [set category "medium-cost" set price 23]
 
 ask n-of 17 restaurants with [category = "medium-cost"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                          set nCovers 40]
 ask n-of 7 restaurants with [category = "medium-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                 set nCovers 50]
 ask n-of 2 restaurants with [category = "medium-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                 set nCovers 50]
 
 ask n-of 3 restaurants with [category = "nil"] [set category "high-cost" set price 30]
 
 ask n-of 2 restaurants with [category = "high-cost"] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                       set nCovers 75]
 ask one-of restaurants with [category = "high-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                               set nCovers 100]

 ask restaurants [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                   set myzone ([area] of mypatch)]
 
 set totNcovers1 sum [ncovers] of restaurants with [category = "low-cost"]
 set totNcovers2 sum [ncovers] of restaurants with [category = "medium-cost"]
 set totNcovers3 sum [ncovers] of restaurants with [category = "high-cost"]
 
 end
 
 
 to init-Retailers
 create-retailers 115 [ set category "nil" set mypatch patch 0 0   set color blue set size 0.2] 
 
 ask n-of 14 retailers with [category = "nil"] [set category "food" set m2 random-normal 200 100 set price 15 ]; supermarkets and food
 ask n-of 13 retailers with [category = "food"] [set mypatch one-of patches with [area = 2 and lUse = 1]] 
 ask one-of retailers with [category = "food" and mypatch =  patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]] 
 
 ask n-of 17 retailers with [category = "nil"] [set category "souvenirs" set m2 random-normal 100 50 set price 8] ;gifts and souvenirs
 ask n-of 12 retailers with [category = "souvenirs"] [set mypatch one-of patches with [area = 2 and lUse = 1]] 
 ask n-of 5 retailers with [category = "souvenirs" and mypatch =  patch 0 0] [set mypatch one-of patches with [area = 2 and lUse = 1]] 
 
 ask n-of 61 retailers with [category = "nil"] [set category "bars" set m2 random-normal 150 25 set price 5] ; bars and pubs
 ask n-of 40 retailers with [category = "bars"] [set mypatch one-of patches with [area = 2 and lUse = 1]]
 ask n-of 12 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]] 
 ask n-of 3 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]]
 ask n-of 2 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]]
 ask one-of retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 11 and lUse = 2]]
 ask n-of 3 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 5 and lUse = 2]]
 
 ask n-of 23 retailers with [category = "nil"] [set category "clothes" set m2 random-normal 100 50 set price 30] ; clothes, rentals and sunglasses
 ask n-of 20 retailers with [category = "clothes"] [set mypatch one-of patches with [area = 2 and lUse = 1]]
 ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]] 
 ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 5 and lUse = 2]] 
 ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]] 
 
 ask retailers [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                set myzone ([area] of mypatch) ]
 
 set totm2ret1 sum [m2] of retailers with [category = "bars"]
 set totm2ret2 sum [m2] of retailers with [category = "souvenirs"]
 set totm2ret3 sum [m2] of retailers with [category = "food"]
 set totm2ret4 sum [m2] of retailers with [category = "clothes"]
 
 end
 
 
 to init-OtherFacilities
 create-otherfacilities 8 [set category "nil" set mypatch patch 0 0   set color green set size 0.2]
 
 ask n-of 1 otherfacilities with [category = "nil"][set category "kindergarten" set CCC 60 set price 20 ;kids facilities
                                                    set mypatch one-of patches with [area = 2 and lUse = 1] ]
 
 ask n-of 4 otherfacilities with [category = "nil"][set category "wellness" set CCC 20 set price 14] ; wellness-spa facilities
 ask n-of 3 otherfacilities with [category = "wellness"] [set mypatch one-of patches with [area = 2 and lUse = 1]]
 ask one-of otherfacilities with [category = "wellness" and mypatch = patch 0 0 ] [set mypatch one-of patches with [area = 3 and lUse = 2]]
 
 ask  n-of 3 otherfacilities with [category = "nil"] [set category "other-sports" set price 10] ;other sports: gim, ice stadium, ice karts
 ask one-of otherfacilities with [category = "other-sports"] [set mypatch one-of patches with [area = 2 and lUse = 1] set CCC 200]
 ask one-of otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 2 and lUse = 2]
                                                                                      set CCC 1000]
 ask one-of otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 6 and lUse = 2]
                                                                                       set CCC 50] 

 ask otherfacilities [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                      set myzone ([area] of mypatch)  ]
 
 
 set totCCCof1 sum [CCC] of otherfacilities with [category = "other-sports"]
 set totCCCof2 sum [CCC] of otherfacilities with [category = "welness"]
 set totCCCof1 sum [CCC] of otherfacilities with [category = "kindergarten"]
 
 end
 
 to init-Down_Hills 
 create-Down_Hills 2 [set mypatches 0 set price 27] 
 
 ask one-of Down_Hills [ set myname "monte-agudo" set km2 2 set kmtracks 12 set nlifts 4 set CCC 700 set AS 0.5
                         set mypatches n-of 2 patches with [area = 5 and lUse = 2 ]]
 
 ask one-of Down_hills with [mypatches = 0] [ set myname "col-de-varda" set km2 1 set kmtracks 6 set nlifts 2 set CCC 400 set AS 0.5
                                              set mypatches (patch-set patch 7 -5 patch 7 -6 patch 6 -6)] ;n-of 2 patches with [area = 8 and lUse = 3 ]]
 
 ask down_hills [ ask mypatches [set pcolor 135 set cover "downhill"]
                  set myzone ([area] of one-of mypatches)
                  set hidden? true]
                 
 set totkm2dh sum [km2] of down_hills
 end
 
 
 to init-XCountries
 create-XCountries 2 [set mypatches 0  set snowshoes 0 set AS 0 set price 5]
 
 ask one-of XCountries [ set myname "somadida" set kmtracks 35 set CCC 1050
                         set mypatches n-of 3 patches with [area = 6 and lUse = 2 ]]
 
 ask one-of XCountries  with [mypatches = 0] [set myname "trecime" set kmtracks 15 set CCC 450
                                                  set mypatches n-of 1 patches with [area = 11 and lUse = 2]]
 ask XCountries [ ask mypatches [set pcolor 135 set cover "xcountry"]
                  set myzone ([area] of one-of mypatches)
                  set hidden? true]
 
 set totkmXC sum [kmtracks] of XCountries
 set totkmSS sum [snowshoes] of Xcountries
 end
 
 to init-offpistes
 create-offpistes  3 [set mypatches 0 set price 0]
 
 ask one-of offpistes [set myname "trecime" set nlifts 0 set kmTracks 3 set CCC 75
                       set mypatches n-of 1  patches with [area = 8 and lUse = 3]]   
 
 ask one-of offpistes with [mypatches = 0][ set myname "valdonge" set nlifts 0 set kmTracks 3 set CCC 75
                                           set mypatches n-of 1  patches with [area = 7 and lUse = 3]]   
 
 ask one-of offpistes with [mypatches = 0][ set myname "valdarin" set nlifts 0 set kmTracks 2 set CCC 50
                                           set mypatches n-of 1  patches with [area = 9 and lUse = 3]]   
 ask offpistes [ask mypatches  [set pcolor 135 set cover "offpiste"]
                set myzone ([area] of one-of mypatches)
                set hidden? true]

 set totliftsOP sum [nlifts] of offpistes
 end
 
 
 to init-ReferencePoints  
 create-ReferencePoints 15  [ set SnowCover 0  set fSnowCover 0 set ytemp 0  set temp 0 set snowsecurity 0
                               set mypatch 0 set color black set shape "triangle 2" set size 0.5 set alt-range 0 ]
 
 ask ReferencePoints with [mypatch = 0]  [set mypatch one-of patches with [reference-point = 1 and id = 0] 
                                          ask mypatch [set id myself] ]
 
 ask ReferencePoints [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                      set myzone ([area] of mypatch)]
 
 ask referencepoints with [alt-range = 0 and myzone = 2] [set alt-range 800] 
 ask referencepoints with [alt-range = 0 and myzone = 3] [set alt-range 1700] 
 ask referencepoints with [alt-range = 0 and myzone = 4] [set alt-range 1000] 
 ask referencepoints with [alt-range = 0 and myzone = 5 and pycor = -8] [set alt-range 800] 
 ask referencepoints with [alt-range = 0 and myzone = 5 and pycor = -9] [set alt-range 1400] 
 ask referencepoints with [alt-range = 0 and myzone = 6] [set alt-range 1200] 
 ask referencepoints with [alt-range = 0 and myzone = 7 and pxcor = 7] [set alt-range 1500]
 ask referencepoints with [alt-range = 0 and myzone = 7 and pxcor = 9] [set alt-range 2600]
 ask referencepoints with [alt-range = 0 and myzone = 8 and pxcor = 6] [set alt-range 1500]
 ask referencepoints with [alt-range = 0 and myzone = 8 and pxcor = 8] [set alt-range 2600]
 ask referencepoints with [alt-range = 0 and myzone = 9 and pxcor = 16] [set alt-range 1000]
 ask referencepoints with [alt-range = 0 and myzone = 9 and pxcor = 14] [set alt-range 1600]
 ask referencepoints with [alt-range = 0 and myzone = 10 and pxcor = 12] [set alt-range 1100]
 ask referencepoints with [alt-range = 0 and myzone = 10 and pxcor = 9] [set alt-range 2600]
 ask referencepoints with [alt-range = 0 and myzone = 11] [set alt-range 1800]
                     
 end
 
 to init-zones
   
   create-zones 10 [set myname 0]

   ask one-of zones with [myname = 0] [set myname 2]
   ask one-of zones with [myname = 0] [set myname 3]
   ask one-of zones with [myname = 0] [set myname 4]
   ask one-of zones with [myname = 0] [set myname 5]
   ask one-of zones with [myname = 0] [set myname 6]
   ask one-of zones with [myname = 0] [set myname 7]
   ask one-of zones with [myname = 0] [set myname 8]
   ask one-of zones with [myname = 0] [set myname 9]
   ask one-of zones with [myname = 0] [set myname 10]
   ask one-of zones with [myname = 0] [set myname 11] 
  
   foreach [myname] of zones [
     
     ask zones with [myname = ?] [ 
     set mypatches (patches with [area = ?]) 
     set myreferencepoints (referencepoints with [area = ?]) 
     set nOvernightVisitors 0 set avZoneSnowCover 0 set fAvZoneSnowCover 0
     set mydownhills (Down_hills with [myzone = ?]) 
     set myxcountries (xcountries with [myzone = ?])
     set myoffpistes (offpistes with [myzone = ?])
     set myaccomodations (accomodations with [myzone = ?]) 
     set myrestaurants (restaurants with [myzone = ?]) 
     set myOtherSports (otherfacilities with [category = "other-sports" and myzone = ?])
     set myKidsFacilities (otherfacilities with [category = "kindergarten" and myzone = ?])
     set mywellnesses (otherfacilities with [category = "welness" and myzone = ?])
     set myBars (retailers with [category = "bar" and myzone = ?]) 
     set myFoods (retailers with [category = "food" and myzone = ?])  
     set myClothes (retailers with [category = "clothes" and myzone = ?]) 
     set mySouvenirs (retailers with [category = "souvenirs" and myzone = ?])]]
   
   ask zones [set hidden? true]
 
 end    

 to init-ski-areas
    
    create-ski-areas 2 [set size 0.2 set color black set myname "nil"]
    ask one-of ski-areas with [myname = "nil" ][set myname "misurina ski area" set hidden? true
        set mydownhills  (down_hills with [myzone = 7 or myzone = 8 or myzone = 10])
        set myoffpistes (offpistes with [myzone = 7 or myzone = 8 or myzone = 10])
        set kmdownhills (sum [kmtracks] of mydownhills)  
        set kmoffpistes (sum [kmtracks] of myoffpistes)] 
    
    
   ask one-of ski-areas with [myname = "nil" ][set myname "auronzo ski area" set hidden? true 
        set mydownhills  (down_hills with [myzone = 5 or myzone = 9])
        set myoffpistes (offpistes with [myzone = 5 or myzone = 9])
        set kmdownhills (sum [kmtracks] of mydownhills)  
        set kmoffpistes (sum [kmtracks] of myoffpistes)]    
   
   ask ski-areas [
   ifelse any? myoffpistes with [nlifts > 0] [set free-ride true] [set free-ride false]]
 end


 to visualize-land
  
 If layer = "areas" [
  ask patches with [area = 0] [set pcolor black]
  ask patches with [area = 2] [set pcolor 55 ]
  ask patches with [area = 3] [set pcolor 65 ]
  ask patches with [area = 4] [set pcolor 15 ]
  ask patches with [area = 5] [set pcolor 75 ]
  ask patches with [area = 1] [set pcolor white]
  ask patches with [area = 6] [set pcolor 25 ]
  ask patches with [area = 7] [set pcolor 85 ]
  ask patches with [area = 8] [set pcolor 35 ]
  ask patches with [area = 9] [set pcolor 45 ]
  ask patches with [area = 10] [set pcolor 95]
  ask patches with [area = 11] [set pcolor 105 ]]
 
 If layer = "land use" [
  ask patches with [luse = 0] [set pcolor black]
  ask patches with [luse = 1] [set pcolor white ]
  ask patches with [luse = 2] [set pcolor yellow ]
  ask patches with [luse = 3] [set pcolor green ]]

 end 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; end of setup

;;;;;;;; procedures that are perfomed at every time step;

to go  
  tick 
  check-time 
  ifelse ClimateScenario = "Baseline80-00" [if ticks  > 2520 [stop]]
                                           [if ticks  > 5040 [stop]]
  updateCover
  delete_previous_choices
  
  updateInvestment_accomodations
  updateInvestment_restaurants
  updateInvestment_retailers
  updateInvestment_otherfacilities
  updateInvestment_downhills
  updateInvestment_xcountries
  updateInvestment_snowparks
  updateInvestment_offpistes
  
  doclimate          
  doShortTermForecast
  doMidtermForecast
  doSecurityForecast
  checkForecastFac_2
  checkRealConditions_4
  makeSnow_3
  
  checkDestination 
  initPlanning
  enjoyDestination
  leaveDestination
  
  updateBalance_accomodations
  updateBalance_restaurants
  updateBalance_retailers
  updateBalance_otherfacilities
  updateBalance_downhills
  updateBalance_xcountries
  updateBalance_snowparks
  updateBalance_offpistes
  
  plot-balances
  plot-labour
  plot-energy
  
  updateUsers_8 
  checkOccupation
  calcExpense
  updateNVistors
  calcSatisfaction
  updateSatisfaction
  
end  

to check-time
   set season ((int ((ticks - 1) / 126) + 1)) 
   if ticks >= (126 * (season - 1)) and ticks <= (126 * (season - 1)) + 15 [ set month "Dec 1st half"]
   if ticks > (126 * (season - 1)) + 15 and ticks <= (126 * (season - 1)) + 30 [ set month "Dec 2nd half"]
   if ticks > (126 * (season - 1)) + 30 and ticks <= (126 * (season - 1)) + 45 [ set month "Jan 1st half"]
   if ticks > (126 * (season - 1)) + 45 and ticks <= (126 * (season - 1)) + 60 [ set month "Jan 2nd half"]
   if ticks > (126 * (season - 1)) + 60 and ticks <= (126 * (season - 1)) + 75 [ set month "Feb 1st half"]
   if ticks > (126 * (season - 1)) + 75 and ticks <= (126 * (season - 1)) + 90 [ set month "Feb 2nd half"]
   if ticks > (126 * (season - 1)) + 90 and ticks <= (126 * (season - 1)) + 105 [ set month "Mar 1st half"]
   if ticks > (126 * (season - 1)) + 105 and ticks <= (126 * (season - 1)) + 120 [ set month "Mar 2nd half"]
   if ticks > (126 * (season - 1)) + 120 and ticks <= (126 * (season - 1)) + 126 [ set month "Apr 1st week"]
end   


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to updateCover
if ticks = 127 [

; this procedure can happen in 3 different ways according to the selected development strategy as per slider, updating
; the land cover values and the configuaration of facilities at the 631st time step which is the beginning of the 6th season
; if BAU is selected nothing happends and the procedure is skipped
;it's a re-configuration of the facilties

; First strategy   
If  DevelopmentStrategy = "Ski Intensive" [
  
  set lUse-dataset gis:load-dataset "3lUse_skiN.asc"
  gis:apply-raster lUse-dataset lUse
  
  ask offpistes [die]   
  
  create-Down_Hills 4 [set mypatches 0 set price 27]    
  
  ask one-of Down_hills with [mypatches = 0] [ set myname "torre del diavolo" set km2 1 set kmtracks 9 set nlifts 2 set CCC 400 
                                                  set mypatches n-of 2 patches with [area = 8 and lUse = 2 and cover = "nil"]]
  ask one-of Down_hills with [mypatches = 0] [ set myname "federavecchia" set km2 1 set kmtracks 6 set nlifts 1 set CCC 400 
                                                  set mypatches n-of 2 patches with [area = 7 and lUse = 2 and cover = "nil"]]
  ask one-of Down_hills with [mypatches = 0] [ set myname "valmarzon" set km2 10 set kmtracks 5 set nlifts 2 set CCC 400 
                                                  set mypatches n-of 2 patches with [area = 10 and lUse = 2 and cover = "nil"]]
  ask one-of Down_hills with [mypatches = 0] [ set myname "valdarin" set km2 2 set kmtracks 10 set nlifts 2 set CCC 700 
                                                  set mypatches n-of 2 patches with [area = 9 and lUse = 2 and cover = "nil"]]
  ask down_hills [set AS 0.7 
                  set myzone ([area] of one-of mypatches)
                  ask mypatches [set pcolor 135 set cover "downhill"]
                  set hidden? true]                                            
                                               
                                              
  create-snowparks 2 [ set mypatches 0 set AS 1 set price 10]
 
  ask one-of snowparks with [mypatches = 0] [set nlifts 1 set CCC 150 set km2 0.5 set ntricks 10
                                             set mypatches n-of 2 patches with [area = 5 and lUse = 2]] ;and cover = "nil" ]]
  ask one-of snowparks with [mypatches = 0] [set nlifts 1 set CCC 150 set km2 0.5 set ntricks 15
                                             set mypatches n-of 2 patches with [area = 8 and lUse = 2]] ;and cover = "nil" ]]
 
  ask snowparks [ask mypatches [set pcolor 135 set cover "snowparks"]
                 set myzone ([area] of one-of mypatches)
                 set hidden? true]                                            
 
  
  ask XCountries [set AS 0.2 set price 8]                                            
  
                                              
  create-restaurants 10 [ set category "nil" set mypatch patch 0 0   set color orange set size 0.2]                                            
  
  ask n-of 4 restaurants with [category = "nil"] [set category "low-cost" set price 15]                                                                                       
  ask n-of 3 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                                               set nCovers 45]
  ask n-of 1 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]
                                                                               set nCovers 50]                                            
                                              
  ask n-of 5 restaurants with [category = "nil"] [set category "medium-cost" set price 23]    
  ask n-of 2 restaurants with [category = "medium-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                 set nCovers 50]
  ask n-of 1 restaurants with [category = "medium-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 9 and lUse = 2]
                                                                                 set nCovers 50]                                         
  ask n-of 2 restaurants with [category = "medium-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]
                                                                                 set nCovers 50]                                            
                                              
  ask n-of 1 restaurants with [category = "nil"] [set category "high-cost" set price 30
                                                  set mypatch one-of patches with [area = 2 and lUse = 1] set nCovers 75]                                    
                                              
  ask restaurants [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                   set myzone ([area] of mypatch)]
  
  
  create-retailers 10 [ set category "nil" set mypatch patch 0 0   set color blue set size 0.2] 
 
  ask n-of 7 retailers with [category = "nil"] [set category "bars" set m2 random-normal 200 100 set price 5] ; bars and pubs
  ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 7 and lUse = 2]] 
  ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]]
  ask n-of 2 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 9 and lUse = 2]]
  ask n-of 2 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]]
  ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 11 and lUse = 2]]
 
  ask n-of 3 retailers with [category = "nil"] [set category "clothes" set m2 random-normal 100 50 set price 30] ; clothes, rentals and sunglasses
  ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]] 
  ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 9 and lUse = 2]] 
  ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]] 
 
  ask retailers [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                 set myzone ([area] of mypatch)]                                          
                                              
  
  create-otherfacilities 3 [set category "nil" set mypatch patch 0 0   set color green set size 0.2 
                            set category "kindergarten" set CCC 30 set price 20]
  
  ask n-of 1 otherfacilities with [category = "kindergarten" and mypatch = patch 0 0][
                                   set mypatch one-of patches with [area = 3 and lUse = 1]]    
  ask n-of 1 otherfacilities with [category = "kindergarten" and mypatch = patch 0 0][
                                   set mypatch one-of patches with [area = 5 and lUse = 2]]            
  ask n-of 1 otherfacilities with [category = "kindergarten" and mypatch = patch 0 0][
                                   set mypatch one-of patches with [area = 10 and lUse = 2]]   
  ask otherfacilities [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                       set myzone ([area] of mypatch)]                                                                                              
                                               ]            
                                                                    
; Second Strategy                                              
If  DevelopmentStrategy = "Alternative Ski" [   
   
   set lUse-dataset gis:load-dataset "3lUse_alternativeN.asc"
   gis:apply-raster lUse-dataset lUse
   
   ask offpistes with [myname = "valdonge"] [ set nlifts 1 set kmTracks 6  set CCC 100 set price 25
                                              set mypatches (patch-set (mypatches)  (n-of 1  patches with [area = 7 and lUse = 2 and cover ="nil"]))]                                                                                    
  
   ask offpistes with [myname = "trecime"]  [ set nlifts 1 set kmTracks 6  set CCC 100 set price 25
                                              set mypatches (patch-set (mypatches) (n-of 1 patches with [area = 8 and lUse = 2 and cover = "nil"]))]
   ask offpistes with [myname = "valdarin"] [ set kmTracks 5 set CCC 70
                                              set mypatches (patch-set (mypatches) (n-of 1 patches with [area = 9 and lUse = 3]))]                                                                                   
   
   create-offpistes  1 [ set myname "valmarzon" set nlifts 10 set kmTracks 5 set CCC 100 set price 25
                        set mypatches n-of 2 patches with [area = 10 and lUse = 2 and cover = "nil"]]
   
   ask offpistes [ ask mypatches  [set pcolor 135 set cover "offpiste"]
                  set myzone ([area] of one-of mypatches)
                  set hidden? true]

   
   create-snowparks 1  [ set mypatches 0 set AS 0.8  set price 10]
   
   ask snowparks [set nlifts 1 set CCC 300 set km2 1 set ntricks 10
                  set mypatches n-of 2 patches with [area = 8 and lUse = 2]; and cover = "nil" ]
                  ask mypatches [set pcolor 135 set cover "snowparks"]
                  set myzone ([area] of one-of mypatches)
                  set hidden? true]  
   
   
   ask Xcountries with [myname = "somadida"] [set kmtracks 50 set CCC 1500 set snowshoes 10
                                              set mypatches (patch-set (mypatches) (n-of 1 patches with [area = 6 and lUse = 2 ]))  ] 
   
   ask XCountries with [myname = "trecime"] [set kmtracks 15 set CCC 450 set snowshoes 5
                                             set mypatches (patch-set (mypatches) (n-of 1 patches with [area = 11 and lUse = 2]))]
   
   ask XCountries [ set AS 0
                    ask mypatches [set pcolor 135 set cover "xcountry"]
                    set myzone ([area] of one-of mypatches)] 
    
   
   create-restaurants 4 [ set category "nil" set mypatch patch 0 0  set color orange set size 0.2]                                            
  
   ask n-of 4 restaurants with [category = "nil"] [set category "low-cost" set price 15]                                                                                       
   
   ask n-of 1 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 7 and lUse = 2]
                                                                               set nCovers 50]
   ask n-of 1 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 8 and lUse = 2]
                                                                               set nCovers 50] 
   ask n-of 1 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 9 and lUse = 3]
                                                                               set nCovers 50]
   ask n-of 1 restaurants with [category = "low-cost" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]
                                                                               set nCovers 50] 
   ask restaurants [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                    set myzone ([area] of mypatch)]
  
   
   create-retailers 6 [ set category "nil" set mypatch patch 0 0   set color blue set size 0.2] 
 
   ask n-of 4 retailers with [category = "nil"] [set category "bars"  set m2 random-normal 150 25 set price 5] ; bars and pubs
   ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 6 and lUse = 2]] 
   ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 7 and lUse = 2]]
   ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 9 and lUse = 3]]
   ask n-of 1 retailers with [category = "bars" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]]
  
   ask n-of 2 retailers with [category = "nil"] [set category "clothes" set m2 random-normal 100 50 set price 30] ; clothes, rentals and sunglasses
   ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 6 and lUse = 2]] 
   ask one-of retailers with [category = "clothes" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 10 and lUse = 2]] 
   
   ask retailers [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                  set myzone ([area] of mypatch)]
  
   create-otherfacilities 1 [set category "nil" set color green set size 0.2 set price 20
                             set category "kindergarten"  set CCC 60 
                             set mypatch one-of patches with [area = 3 and lUse = 2]] 
   ask otherfacilities [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                        set myzone ([area] of mypatch)]
  
                                          ]
   
; Third Strategy                          
If  DevelopmentStrategy = "Beyond Snow" [                   
   
   set lUse-dataset gis:load-dataset "3lUse_NonSnowN.asc"
   gis:apply-raster lUse-dataset lUse
   
   ask down_hills [set AS 0]
   
   create-accomodations 9 [ set mypatch patch  0 0   set color red set size 0.2 
                            set category "three-four-stars" set price 43]
  
   ask n-of 4 accomodations with [category = "three-four-stars" and mypatch = patch 0 0] 
                                 [set mypatch one-of patches with [area = 2 and lUse = 1] set nBeds 60]
   ask n-of 3 accomodations with [category = "three-four-stars" and mypatch = patch 0 0] 
                                 [set mypatch one-of patches with [area = 3 and lUse = 1] set nBeds 80]
   ask n-of 2 accomodations with [category = "three-four-stars" and mypatch = patch 0 0] 
                                 [set mypatch one-of patches with [area = 4 and lUse = 1] set nBeds 100]
   
   ask accomodations [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                      set myzone ([area] of mypatch)]
   
   
   create-restaurants 9 [ set mypatch patch 0 0  set color orange set size 0.2                                            
                          set category "high-cost" set price 30]
   
   ask n-of 5 restaurants with [mypatch = patch 0 0] [set mypatch one-of patches with [area = 2 and lUse = 1]
                                                                                       set nCovers 75]
   ask n-of 2 restaurants with [mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                       set nCovers 100] 
   ask n-of 2 restaurants with [mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                       set nCovers 100] 
   ask restaurants [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                    set myzone ([area] of mypatch)]
  
   
   create-retailers 30 [ set category "nil" set mypatch patch 0 0   set color blue set size 0.2] 
 
   ask n-of 1 retailers with [category = "nil"] [set category "food" set m2 random-normal 150 20 set price 15; supermarkets and food
                                                 set mypatch one-of patches with [area = 4 and lUse = 1]] 

   ask n-of 23 retailers with [category = "nil"] [set category "clothes"  set m2 random-normal 100 20 set price 30] 
   ask n-of 10 retailers with [category = "clothes"] [set mypatch one-of patches with [area = 2 and lUse = 1]] 
   ask n-of 8 retailers with [category = "clothes" and mypatch =  patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]] 
   ask n-of 5 retailers with [category = "clothes" and mypatch =  patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]]  

   ask n-of 6 retailers with [category = "nil"] [set category "souvenirs" set m2 random-normal 100 20 set price 8] 
   ask n-of 4 retailers with [category = "souvenirs"] [set mypatch one-of patches with [area = 3 and lUse = 1]]
   ask n-of 2 retailers with [category = "souvenirs" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]] 
 
   ask retailers [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                  set myzone ([area] of mypatch)]
  
   
   create-otherfacilities 16 [set category "nil" set mypatch patch 0 0   set color green set size 0.2]
 
   ask n-of 3 otherfacilities with [category = "nil"][set category "kindergarten" set price 20 ] 
   ask one-of otherfacilities with [category = "kindergarten" and mypatch = patch 0 0 ] 
                                   [set CCC 60 set mypatch one-of patches with [area = 2 and lUse = 1]]
   ask one-of otherfacilities with [category = "kindergarten" and mypatch = patch 0 0 ] 
                                   [set CCC 30 set mypatch one-of patches with [area = 3 and lUse = 1]]
   ask one-of otherfacilities with [category = "kindergarten" and mypatch = patch 0 0 ] 
                                   [set CCC 30 set mypatch one-of patches with [area = 4 and lUse = 1]]                                
   
   ask n-of 5 otherfacilities with [category = "nil"][set category "wellness" set price 14] ; wellness-spa facilities
   ask n-of 1 otherfacilities with [category = "wellness" and mypatch = patch 0 0] 
                                   [set CCC 200 set mypatch one-of patches with [area = 2 and lUse = 1]]
   ask n-of 2 otherfacilities with [category = "wellness" and mypatch = patch 0 0] 
                                   [set CCC 20 set mypatch one-of patches with [area = 3 and lUse = 1]]
   ask n-of 2 otherfacilities with [category = "wellness" and mypatch = patch 0 0 ] 
                                   [set CCC 20 set mypatch one-of patches with [area = 4 and lUse = 1]] 
 
 
   ask  n-of 8 otherfacilities with [category = "nil"] [set category "other-sports" set price 10 ] ;other sports: gim, ice stadium, ice karts
   ask one-of otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 2 and lUse = 1] set CCC 200]
 
   ask n-of 4 otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 3 and lUse = 1]
                                                                                        set CCC 50]
   ask one-of otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 4 and lUse = 1]
                                                                                        set CCC 50] 
   ask n-of 2 otherfacilities with [category = "other-sports" and mypatch = patch 0 0] [set mypatch one-of patches with [area = 6 and lUse = 2]
                                                                                        set CCC 50] 

   ask otherfacilities [let x ([pxcor] of mypatch) let y ([pycor] of mypatch) set xcor x set ycor y
                        set myzone ([area] of mypatch)]
                                      ]  

;;;;;;;;;; then, independently from the choosen strategy
   
   checkDestinationParameters
   
   set newtotNbeds1 sum [nbeds] of Accomodations with [category = "extrahotels"]
   set newtotNbeds2 sum [nbeds] of Accomodations with [category = "one-two-stars"]
   set newtotNbeds3 sum [nbeds] of Accomodations with [category = "three-four-stars"]
 
   set newtotNcovers1 sum [ncovers] of restaurants with [category = "low-cost"]
   set newtotNcovers2 sum [ncovers] of restaurants with [category = "medium-cost"]
   set newtotNcovers3 sum [ncovers] of restaurants with [category = "high-cost"]
 
   set newtotm2ret1 sum [m2] of retailers with [category = "bars"]
   set newtotm2ret2 sum [m2] of retailers with [category = "souvenirs"]
   set newtotm2ret3 sum [m2] of retailers with [category = "food"]
   set newtotm2ret4 sum [m2] of retailers with [category = "clothes"]
 
   set newtotCCCof1 sum [CCC] of otherfacilities with [category = "other-sports"]
   set newtotCCCof2 sum [CCC] of otherfacilities with [category = "welness"]
   set newtotCCCof1 sum [CCC] of otherfacilities with [category = "kindergarten"]

   set newtotkm2dh sum [km2] of down_hills
 
   set newtotkmXC sum [kmtracks] of XCountries
   set newtotkmSS sum [snowshoes] of Xcountries

   set newtotliftsOP sum [nlifts] of offpistes
 
   set newtotliftsSP sum [nlifts] of snowparks
   set newtotkm2SP sum [km2] of snowparks
   
    foreach [myname] of zones [
     
     ask zones with [myname = ?] [ 
     set mypatches (patches with [area = ?]) 
     set myreferencepoints (referencepoints with [area = ?]) 
     set nOvernightVisitors 0 set avZoneSnowCover 0 set fAvZoneSnowCover 0
     set mydownhills (Down_hills with [myzone = ?]) 
     set myxcountries (xcountries with [myzone = ?])
     set myoffpistes (offpistes with [myzone = ?])
     set mysnowparks (snowparks with [myzone = ?])
     set myaccomodations (accomodations with [myzone = ?]) 
     set myrestaurants (restaurants with [myzone = ?]) 
     set myOtherSports (otherfacilities with [category = "other-sports" and myzone = ?])
     set myKidsFacilities (otherfacilities with [category = "kindergarten" and myzone = ?])
     set mywellnesses (otherfacilities with [category = "welness" and myzone = ?])
     set myBars (retailers with [category = "bar" and myzone = ?]) 
     set myFoods (retailers with [category = "food" and myzone = ?])  
     set myClothes (retailers with [category = "clothes" and myzone = ?]) 
     set mySouvenirs (retailers with [category = "souvenirs" and myzone = ?])]]
    
   ask ski-areas with [myname = "misurina ski area"] [
        set mydownhills  (down_hills with [myzone = 7 or myzone = 8 or myzone = 10])
        set myoffpistes (offpistes with [myzone = 7 or myzone = 8 or myzone = 10])
        set kmdownhills (sum [kmtracks] of mydownhills)  
        set kmoffpistes (sum [kmtracks] of myoffpistes)]  

   ask ski-areas with [myname = "auronzo ski area"] [
        set mydownhills  (down_hills with [myzone = 5 or myzone = 9])
        set myoffpistes (offpistes with [myzone = 5 or myzone = 9])
        set kmdownhills (sum [kmtracks] of mydownhills)  
        set kmoffpistes (sum [kmtracks] of myoffpistes)]    
   
   ask ski-areas [
   ifelse any? myoffpistes with [nlifts > 0] [set free-ride true] [set free-ride false]]
]
end 


;end of reconfiguration of the sixt year;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;economic part of the model

;;;;;;;;;;;;;;;;;;;;;
;accomodations

to updateInvestment_accomodations  
 if ticks = 127 [ 
 let totinvest1 (15000 * (newtotNbeds1 - totNbeds1)) 
 let totinvest2 (25000 * (newtotNbeds2 - totNbeds2)) 
 let totinvest3 (45000 * (newtotNbeds3 - totNbeds3))
 set newtotNbeds (newtotnbeds1 + newtotnbeds2 + newtotnbeds3)
 let fc1 (1 * newtotnbeds1)
 let fc2 (2 * newtotnbeds2)
 let fc3 (3 * newtotnbeds3)
 let vc1 (3 * newtotnbeds1)
 let vc2 (4 * newtotnbeds2)
 let vc3 (5 * newtotnbeds3)
 let ap1 (22 * newtotnbeds1)
 let ap2 (30 * newtotnbeds2)
 let ap3 (43 * newtotnbeds3)
 
 ask MEAs with [category = "accomodations"] [set totalInvestment (totinvest1 + totinvest2 + totinvest3)
                                             set avfixedcostunit ((fc1 + fc2 + fc3) / newtotnbeds)
                                             set avVarCostUnit ((vc1 + vc2 + vc3) / newtotnbeds)
                                             set avPrice ((ap1 + ap2 + ap3) / newtotnbeds) ]]
 
 if ticks = 1 [
 set totNbeds (totnbeds1 + totnbeds2 + totnbeds3)
 let fc1 (1 * totnbeds1)
 let fc2 (2 * totnbeds2)
 let fc3 (3 * totnbeds3)
 let vc1 (3 * totnbeds1)
 let vc2 (4 * totnbeds2)
 let vc3 (5 * totnbeds3)
 let ap1 (22 * totnbeds1)
 let ap2 (30 * totnbeds2)
 let ap3 (43 * totnbeds3)
 
 ask MEAs with [category = "accomodations"] [set avfixedcostunit ((fc1 + fc2 + fc3) / totnbeds)
                                             set avVarCostUnit ((vc1 + vc2 + vc3) / totnbeds)
                                             set avPrice ((ap1 + ap2 + ap3) / totnbeds)]]    
end

to updateBalance_accomodations
let n (sum [users] of accomodations)  

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "accomodations"] [
 set hlabour hlabour + (avVarcostunit * n)
 set energy energy + (avfixedcostunit * newtotNbeds)
 set return (((avPrice - avVarcostunit) * n) - (avfixedcostunit * newtotNbeds) - (totalinvestment / 4914))
 set balance (balance + return)
 set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

if ticks <= 126 or DevelopmentStrategy = "BAU" [
ask meas with [category = "accomodations"] [
    set hlabour hlabour + (avVarcostunit * n) 
    set energy energy + (avfixedcostunit * totNbeds)
    set return ((avPrice - avVarcostunit) * n) - (avfixedcostunit * totNbeds)
    set balance (balance + return) 
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 
    
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;restaurants 

to updateInvestment_restaurants
 if ticks = 127 [  
   
 let totinvest1 (3500 * (newtotNcovers1 - totNcovers1)) 
 let totinvest2 (6000 * (newtotNcovers2 - totNcovers2)) 
 let totinvest3 (9000 * (newtotNcovers3 - totNcovers3))
 set newtotNcovers (newtotNcovers1 + newtotNcovers2 + newtotNcovers3)
 let fc1 (0.25 * newtotNcovers1)
 let fc2 (0.50 * newtotNcovers2)
 let fc3 (0.75 * newtotNcovers3)
 let vc1 (0.5 * newtotNcovers1)
 let vc2 (1 * newtotNcovers2)
 let vc3 (1.5 * newtotNcovers3)
 let ap1 (15 * newtotNcovers1)
 let ap2 (23 * newtotNcovers2)
 let ap3 (30 * newtotNcovers3)
 
 ask MEAs with [category = "restaurants"] [set totalInvestment (totinvest1 + totinvest2 + totinvest3)
                                             set avfixedcostunit ((fc1 + fc2 + fc3) / newtotNcovers)
                                             set avVarCostUnit ((vc1 + vc2 + vc3) / newtotNcovers)
                                             set avPrice ((ap1 + ap2 + ap3) / newtotNcovers)]   ]
 if ticks = 1 [ 
 set totNcovers (totNcovers1 + totNcovers2 + totNcovers3)
 let fc1 (0.25 * totNcovers1)
 let fc2 (0.50 * totNcovers2)
 let fc3 (0.75 * totNcovers3)
 let vc1 (0.5 * totNcovers1)
 let vc2 (1 * totNcovers2)
 let vc3 (1.5 * totNcovers3)
 let ap1 (15 * totNcovers1)
 let ap2 (23 * totNcovers2)
 let ap3 (30 * totNcovers3)
 
 ask MEAs with [category = "restaurants"] [  set avfixedcostunit ((fc1 + fc2 + fc3) / totNcovers)
                                             set avVarCostUnit ((vc1 + vc2 + vc3) / totNcovers)
                                             set avPrice ((ap1 + ap2 + ap3) / totNcovers)]   ]
end  

to updateBalance_restaurants
let n (sum [users] of restaurants)   

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "restaurants"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * newtotNcovers)
    set return (((avPrice - avVarcostunit) * n)  - (avfixedcostunit * newtotNcovers) - (totalinvestment / 4914))
    set balance (balance + return)
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]]  

if ticks <= 126 or DevelopmentStrategy = "BAU" [ 
ask meas with [category = "restaurants"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * totNcovers)
    set return ((avPrice - avVarcostunit) * n) - (avfixedcostunit * totNcovers)
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; retailers

to updateInvestment_retailers
 
 if ticks = 127 [   
 
 let totinvest1 (4000 * (newtotm2ret1 - totm2ret1)) 
 let totinvest2 (3000 * (newtotm2ret2 - totm2ret2)) 
 let totinvest3 (4000 * (newtotm2ret3 - totm2ret3))
 let totinvest4 (3000 * (newtotm2ret4 - totm2ret4)) 
 set newtotm2ret (newtotm2ret1 + newtotm2ret2 + newtotm2ret3)
 let fc1 (40 * newtotm2ret1)
 let fc2 (30 * newtotm2ret2)
 let fc3 (50 * newtotm2ret3)
 let fc4 (30 * newtotm2ret4)
 let ap1 (5 * newtotm2ret1)
 let ap2 (8 * newtotm2ret2)
 let ap3 (15 * newtotm2ret3)
 let ap4 (30 * newtotm2ret4)
 
 ask MEAs with [category = "retailers"] [set totalInvestment (totinvest1 + totinvest2 + totinvest3 + totinvest4)
                                             set avfixedcostunit ((fc1 + fc2 + fc3 + fc4) / newtotm2ret)
                                             set avVarCostUnit 0.5
                                             set avPrice ((ap1 + ap2 + ap3 + ap4) / newtotm2ret)]] 
 if ticks = 1 [
 set totm2ret (totm2ret1 + totm2ret2 + totm2ret3)
 let fc1 (40 * totm2ret1)
 let fc2 (30 * totm2ret2)
 let fc3 (50 * totm2ret3)
 let fc4 (30 * totm2ret4)
 let ap1 (5 * totm2ret1)
 let ap2 (8 * totm2ret2)
 let ap3 (15 * totm2ret3)
 let ap4 (30 * totm2ret4)
 
 ask MEAs with [category = "retailers"] [    set avfixedcostunit ((fc1 + fc2 + fc3 + fc4) / totm2ret)
                                             set avVarCostUnit 0.5
                                             set avPrice ((ap1 + ap2 + ap3 + ap4) / totm2ret)] ]      
end  

to updateBalance_retailers
let n (sum [users] of retailers) 

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "retailers"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * newtotm2ret / 126)
    set return (((avPrice - avVarcostunit ) * n) - (avfixedcostunit * newtotm2ret / 126) - (totalinvestment / 4914))
    set balance (balance + return)
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]]    

if ticks <= 126 or DevelopmentStrategy = "BAU" [ 
ask meas with [category = "retailers"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * totm2ret / 126)
    set return (((avPrice - avVarcostunit ) * n) - (avfixedcostunit * totm2ret / 126))
    set balance (balance + return)
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; other facilities

to updateInvestment_otherfacilities
 if ticks = 127 [   
 
 let totinvest1 (4000 * (newtotCCCof1 - totCCCof1)) 
 let totinvest2 (4000 * (newtotCCCof2 - totCCCof2)) 
 let totinvest3 (2500 * (newtotCCCof3 - totCCCof3)) 
 set newtotCCCof (newtotCCCof1 + newtotCCCof2 + newtotCCCof3)
 let fc1 (80 * newtotCCCof1)
 let fc2 (100 * newtotCCCof2)
 let fc3 (60 * newtotCCCof3)
 let vc1 (0.5 * newtotCCCof1)
 let vc2 (3 * newtotCCCof2)
 let vc3 (5 * newtotCCCof3)
 let ap1 (10 * newtotCCCof1)
 let ap2 (14 * newtotCCCof2)
 let ap3 (20 * newtotCCCof3)
 
 ask MEAs with [category = "otherfacilities"] [set totalInvestment (totinvest1 + totinvest2 + totinvest3)
                                               set avfixedcostunit ((fc1 + fc2 + fc3) / newtotCCCof)
                                               set avVarCostUnit ((vc1 + vc2 + vc3) / newtotCCCof)
                                               set avPrice ((ap1 + ap2 + ap3) / newtotCCCof)] ]
 if ticks = 1 [
 set totCCCof (totCCCof1 + totCCCof2 + totCCCof3)
 let fc1 (80 * totCCCof1)
 let fc2 (100 * totCCCof2)
 let fc3 (60 * totCCCof3)
 let vc1 (0.5 * totCCCof1)
 let vc2 (3 * totCCCof2)
 let vc3 (5 * totCCCof3)
 let ap1 (10 * totCCCof1)
 let ap2 (14 * totCCCof2)
 let ap3 (20 * totCCCof3)
 
 ask MEAs with [category = "otherfacilities"] [set avfixedcostunit ((fc1 + fc2 + fc3) / totCCCof)
                                               set avVarCostUnit ((vc1 + vc2 + vc3) / totCCCof)
                                               set avPrice ((ap1 + ap2 + ap3) / totCCCof)] ] 
end

to updateBalance_otherfacilities
let n (sum [users] of otherfacilities)   

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "otherfacilities"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * newtotCCCof / 126)
    set return (((avPrice - avVarcostunit ) * n) - (avfixedcostunit * newtotCCCof / 126) - (totalinvestment / 4914))
    set balance (balance + return)
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

if ticks <= 126 or DevelopmentStrategy = "BAU" [    
ask meas with [category = "otherfacilities"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (avfixedcostunit * totCCCof / 126)
    set return (((avPrice - avVarcostunit ) * n) - (avfixedcostunit * totCCCof / 126))
    set balance (balance + return)
    set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 
 
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; downhill facilities

to updateInvestment_downhills

ask MEAs with [category = "downhills"][
if ticks = 127 [set totalinvestment (3000000 * (newtotkm2dh - totkm2dh))] 
if ticks = 1 [set totalinvestment 0]
set avVarCostUnit 5  
set avfixedcostunit 50000
set avPrice 27]
 
end

to updateBalance_DownHills
let n (sum [users] of down_hills) 
set totartsnowcostDH sum [artsnowcost] of down_hills
set totcumartsnowcost totcumartsnowcost + totartsnowcostDH

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "downhills"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + ((avfixedcostunit * newtotKm2dh) / 126) + (totartsnowcostDH * 0.6)
    set return (((avPrice - avVarcostunit ) * n) - totartsnowcostDH - ((avfixedcostunit * newtotKm2dh) / 126) - (totalinvestment / 4914))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

if ticks <= 126 or DevelopmentStrategy = "BAU" [     
ask meas with [category = "downhills"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + ((avfixedcostunit * totKm2dh) / 126) + (totartsnowcostDH * 0.6)
    set return (((avPrice - avVarcostunit ) * n) - totartsnowcostDH - ((avfixedcostunit * totKm2dh) / 126))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; xcountry facilities

to updateInvestment_Xcountries

ask MEAs with [category = "xcountries"][
if ticks = 127 [set totalinvestment (2000 * ((newtotkmxc - totkmxc) +  (newtotkmss - totkmss)))] 
if ticks = 1 [set totalinvestment 0]
set avVarCostUnit 0.5  
set avPrice 5]  

end

to updateBalance_Xcountries
let n (sum [users] of xcountries)   
set totartsnowcostXC sum [artsnowcost] of xcountries
set totcumartsnowcost totcumartsnowcost + totartsnowcostXC

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "xcountries"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (totartsnowcostXC * 0.6)
    set return (((avPrice - avVarcostunit ) * n) - totartsnowcostXC - (totalinvestment / 4914))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

if ticks <= 126 or DevelopmentStrategy = "BAU" [      
ask meas with [category = "xcountries"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + (totartsnowcostXC * 0.6)
    set return (((avPrice - avVarcostunit ) * n) - totartsnowcostXC)
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; offpiste facilities

to updateInvestment_offpistes
  
ask MEAs with [category = "offpistes"][
if ticks = 127 [set totalinvestment (3000000 * (newtotliftsOP - totliftsOP))] 
if ticks = 1 [set totalinvestment 0]
set avVarCostUnit 7
set avFixedCostUnit 25000  
set avPrice 25]    

end

to updateBalance_offpistes
let n (sum [users] of offpistes with [nlifts > 0])  

if ticks > 126 and DevelopmentStrategy != "BAU" [ 
ask meas with [category = "offpistes"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + ((avfixedcostunit * newtotliftsOP) / 126)
    set return (((avPrice - avVarcostunit ) * n) - ((avfixedcostunit * newtotliftsOP) / 126) - (totalinvestment / 4914))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]]      

if ticks <= 126 or DevelopmentStrategy = "BAU" [ 
ask meas with [category = "offpistes"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + ((avfixedcostunit * totliftsOP) / 126)
    set return (((avPrice - avVarcostunit ) * n) - ((avfixedcostunit * totliftsOP) / 126))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 

end

;;;;;;;;;;;;;;;;;;;;;;;;;
; snowpark facilities

to updateInvestment_snowparks

if any? snowparks [
ask MEAs with [category = "snowparks"][
if ticks = 127 [set totalinvestment (1000000 * (newtotkm2SP))] 
set avVarCostUnit 1
set avFixedCostUnit 10000  
set avPrice 10]]   

end

to updateBalance_snowparks

if any? snowparks [
let n sum [users] of snowparks
set totartsnowcostSP sum [artsnowcost] of snowparks
set totcumartsnowcost totcumartsnowcost + totartsnowcostSP

ask meas with [category = "snowparks"] [
    set hlabour hlabour + (avVarcostunit * n)
    set energy energy + ((avfixedcostunit * newtotliftsSP) / 126) + (totartsnowcostSP * 0.6)
    set return (((avPrice - avVarcostunit ) * n) - totartsnowcostSP - ((avfixedcostunit * newtotliftsSP) / 126) - (totalinvestment / 4914))
    set balance (balance + return)
     set seabalance (seabalance + return)
 if (ticks mod 126 = 1) [set hlabour 0 set energy 0 set seabalance 0]]] 
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;end of economic part

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; climatic part of the model;;; need data from skisim


to doClimate  
;;;;;;;;;;;;;;;;;;;;;; use climate data input from arrays  
 
ask referencepoints with [alt-range = 800]
[if ticks != 1 [set ytemp array:item temp_800 (ticks - 2)]
 set temp  array:item temp_800 (ticks - 1)
 set snowcover array:item cover_800 (ticks - 1 )]

ask referencepoints with [alt-range = 1000]
[if ticks != 1 [set ytemp array:item temp_1000 (ticks - 2)]
 set temp  array:item temp_1000 (ticks - 1)
 set snowcover array:item cover_1000 (ticks - 1 )]

ask referencepoints with [alt-range = 1100]
[if ticks != 1 [set ytemp array:item temp_1100 (ticks - 2)]
 set temp  array:item temp_1100 (ticks - 1)
 set snowcover array:item cover_1100 (ticks - 1 )]

ask referencepoints with [alt-range = 1200]
[if ticks != 1 [set ytemp array:item temp_1200 (ticks - 2)]
 set temp  array:item temp_1200 (ticks - 1)
 set snowcover array:item cover_1200 (ticks - 1 )]

ask referencepoints with [alt-range = 1400]
[if ticks != 1 [set ytemp array:item temp_1400 (ticks - 2)]
 set temp  array:item temp_1400 (ticks - 1)
 set snowcover array:item cover_1400 (ticks - 1 )]

ask referencepoints with [alt-range = 1500]
[if ticks != 1 [set ytemp array:item temp_1500 (ticks - 2)]
 set temp  array:item temp_1500 (ticks - 1)
 set snowcover array:item cover_1500 (ticks - 1 )]

ask referencepoints with [alt-range = 1600]
[if ticks != 1 [set ytemp array:item temp_1600 (ticks - 2)]
 set temp  array:item temp_1600 (ticks - 1)
 set snowcover array:item cover_1600 (ticks - 1 )]

ask referencepoints with [alt-range = 1700]
[if ticks != 1 [set ytemp array:item temp_1700 (ticks - 2)]
 set temp  array:item temp_1700 (ticks - 1)
 set snowcover array:item cover_1700 (ticks - 1 )]

ask referencepoints with [alt-range = 1800]
[if ticks != 1 [set ytemp array:item temp_1800 (ticks - 2)]
 set temp  array:item temp_1800 (ticks - 1)
 set snowcover array:item cover_1800 (ticks - 1 )]

ask referencepoints with [alt-range = 2600]
[if ticks != 1 [set ytemp array:item temp_2600 (ticks - 2)]
 set temp  array:item temp_2600 (ticks - 1)
 set snowcover array:item cover_2600 (ticks - 1 )]

end

to doShortTermForecast

ask referencepoints [
let err random-normal 10 3
ifelse random-float 1 < 0.5 [set fsnowcover (snowcover + err)]
                            [set fsnowcover (snowcover - err)
                             if fsnowcover < 0 [set fsnowcover 0]]]

ask zones [ set fAvZoneSnowCover (sum [fsnowcover] of myreferencepoints / count myreferencepoints)
            set avZoneSnowCover (sum [snowcover] of myreferencepoints / count myreferencepoints)
            set maxZoneTemp (max [temp] of myreferencepoints) ]

set avDestsnowcover ((sum [avZoneSnowCover] of zones) / (count zones))

plot-snowcover
plot-temp
end

to doMidtermForecast

set avDestsnowcover ((sum [avZoneSnowCover] of zones) / (count zones))
if avDestsnowcover > historicmaxcover [set historicmaxcover avDestsnowcover
                                       set tickmax (ticks - ((season - 1) * 126))]
if (ticks mod 126 = 2) [set historicmaxcover 30]
set tickstar (tickmax + ((season - 1) * 126))
plot-tickmax

end 

to doSecurityForecast

ask referencepoints [ifelse snowcover > 30 and (temp - ytemp) > 5
                     [set snowsecurity 5]
                     [set snowsecurity 1]]
set avDestSnowSecurity ((sum [snowsecurity] of referencepoints) / (count referencepoints))
; with avDestsnowsecurity > 2 is dangerous and > 3 very dangerous
plot-snowsecurity
end

to checkForecastFac_2

ask offpistes [
let z myzone 
set favsnowcover ( [fAvZoneSnowCover] of one-of zones with [myname = z])]

ask xcountries [
let z myzone 
set favsnowcover ( [fAvZoneSnowCover] of one-of zones with [myname = z])]

end

to checkRealConditions_4

ask offpistes [
let z myzone 
set avsnowcover ( [avZoneSnowCover] of one-of zones with [myname = z])]

ask xcountries [
let z myzone 
set avsnowcover ( [avZoneSnowCover] of one-of zones with [myname = z])
set maxtemp ([maxZoneTemp] of one-of zones with [myname = z])]

ask down_hills [
let z myzone 
set avsnowcover ( [AvZoneSnowCover] of one-of zones with [myname = z])
set maxtemp ([maxZoneTemp] of one-of zones with [myname = z])]

if ticks  > 10 [ ask snowparks [
let z myzone 
set avsnowcover ([AvZoneSnowCover] of one-of zones with [myname = z])
set maxtemp ([maxZoneTemp] of one-of zones with [myname = z])]]

end

to makeSnow_3

ask down_hills [
   set artsnowcost 0
   if (avSnowCover >= 30)[set natsnowday natsnowday + 1]
  
   if  (maxTemp < 0) and (avSnowCover < 30)[
   if (avSnowCover > 20) [set artSnowCost (200 * AS * (kmtracks)) set snow20-30 snow20-30 + 1 ]
   if (avSnowCover >= 0 and avSnowCover <= 10 ) [set artSnowCost (1000 * AS * (kmtracks)) set snow0-10 snow0-10 + 1]  
   if (avSnowCover > 10 and avSnowCover <= 20 )[set artSnowCost (500 * AS * (kmtracks)) set snow10-20 snow10-20 + 1]
   set avSnowCover 30 
   set artSnowDay artSnowDay + 1
   set cumArtSnowCost cumArtSnowCost + artSnowCost]
   
   if (ticks mod 126 = 1) [set cumArtSnowCost 0 set artSnowDay 0 set natsnowday 0 set snow0-10 0 set snow10-20 0 set snow20-30 0]]
  
if any? snowparks [ ask snowparks  [
   set artsnowcost 0
   if (avSnowCover >= 30)[set natsnowday natsnowday + 1]
   if (maxTemp < 0) and (avSnowCover < 30)[
   if ((30 - avSnowCover) <= 10) [set artSnowCost (200 * AS * (km2))]
   ifelse ((30 - avSnowCover) >= 20) [set artSnowCost (1000 * AS * (km2))] [set artSnowCost (500 * AS * (km2))]
   set avSnowCover 30
   set artSnowDay artSnowDay + 1
   set cumArtSnowCost cumArtSnowCost + artSnowCost]
   if (ticks mod 126 = 1) [set cumArtSnowCost 0 set artSnowDay 0 set natsnowday 0]]]

ask xcountries [
   set artsnowcost 0
   if (avSnowCover >= 30)[set natsnowday natsnowday + 1]
   if (maxTemp < 0) and (avSnowCover < 30)[
   if ((30 - avSnowCover) <= 10) [set artSnowCost (200 * AS * (kmtracks))]
   ifelse ((30 - avSnowCover) >= 20) [set artSnowCost (900 * AS * (kmtracks))] [set artSnowCost (400 * AS * (kmtracks))]
   set avSnowCover 30
   set artSnowDay artSnowDay + 1
   set cumArtSnowCost cumArtSnowCost + artSnowCost]
   if (ticks mod 126 = 1) [set cumArtSnowCost 0 set artSnowDay 0 set natsnowday 0]]

if ticks mod 126 = 1 [set totcumartsnowcost 0]

plot-ArtSnow
plot-ArtSnowDay

end  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; end of climatic part

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; behavioural part of the model; this is about the 8 categories of tourists and their decision making process

to delete_previous_choices

ask tourists with [destination = "yes"] [
set busy "no"
set expense 0
set myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0
set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0
set own-daily-transfer 0]

ask tourists with [destination = "yes"] [if ticks > (planning + stay) [
set destination "no"    
set planning 0
set satisfaction 0
set busy "no"    
set myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0 set own-daily-transfer 0
set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0  set myAccomodation 0]]

ask down_hills [set users 0]
ask xcountries [set users 0]
ask offpistes [set users 0]
if any? snowparks [ask snowparks [set users 0]]
ask retailers[set users 0]
ask restaurants [set users 0]
ask otherfacilities [set users 0]

ask patches [set occupation 0]
set nagents 0

end

to checkDestination
if (ticks - 1) mod 126 = 0 [
  
ask tourists with [destination = "no" and planning = 0] [  
  
  if category = "TSI" [
  ifelse random-float 1 < comp and
  (km-downhill > KM-threshold)  [set potential "yes"] [set potential "no"]]

  if category = "SPT" [
  ifelse random-float 1 < comp and
  (km-downhill > KM-threshold) and (nature-ratio > Nature-threshold) 
  [set potential "yes"] [set potential "no"]]

  if category = "SAW"[
  ifelse random-float 1 < comp and
  (km-offpiste > KM-threshold) and (nature-ratio > Nature-threshold) 
  [set potential "yes"] [set potential "no"] ]

  if category = "SAX"[
  ifelse random-float 1 < comp and
  (km-xcountry > KM-threshold) and (nature-ratio > Nature-threshold) 
  [set potential "yes"] [set potential "no"] ]

  if category = "CCW"[
  ifelse random-float 1 < comp and
  (km-freeride > KM-threshold) and (nature-ratio > Nature-threshold) 
  [set potential "yes"] [set potential "no"] ]

  if category = "CCP"[
  ifelse random-float 1 < comp and
  (h > 0 and tricks-sp > tricks-threshold) or (i > 0 and tricks-sp > tricks-threshold) 
  [set potential "yes"] [set potential "no"]]

  if category = "ID"[
  ifelse random-float 1 < comp and
   ( (cc-kindergarten > kids-threshold) and (nwellness > wellness-threshold) and (nature-ratio > Nature-threshold)) 
  [set potential "yes"] [set potential "no"] ]

  if category = "EC"[
  ifelse random-float 1 < comp and
  ( (nothersport > sports-threshold) and (nwellness > wellness-threshold) and (nqualityhotels > qualityhotels-threshold) and (boutique-ratio > boutiques-threshold))
  [set potential "yes"] [set potential "no"] ]
                                                            ]
]
end 

to initPlanning

ask tourists with [potential = "yes" and planning = 0] [ 


if (category = "TSI" or category = "ID" or category = "SPT" or category = "EC" or category = "CCP") 
                   [doplanning]
                   
;if (category = "SPT" and kids = "yes") 
;                   [doplanning]
;
;if (category = "SPT" and kids = "no") 
;                   [checkForecastTour]
                           
if (category = "SAW" or category = "SAX" or category = "CCW") 
                   [checkForecastTour]                                                           ]                            

ask tourists with  [potential = "yes" and planning != 0][
  
  if (planning = ticks) [set destination "yes" set dest-counter dest-counter + 1
                         goDestination
                         if stay != 0 [set arrivals arrivals + gsize ]]]                    

end

to goDestination

if category = "TSI" [set gsize round (random-normal gsize-mean-TSI gsize-sd-TSI) ifelse random-float 1 < pos=0-TSI  
                    [set stay 0][set stay round (random-normal stay-mean-TSI stay-sd-TSI) ]]

if category = "SPT" [set gsize round (random-normal gsize-mean-SPT gsize-sd-SPT) ifelse random-float 1 < pos=0-SPT 
                    [set stay 0][set stay round (random-normal stay-mean-SPT stay-sd-SPT) ]]

if category = "SAX" [set gsize round (random-normal gsize-mean-SAX gsize-sd-SAX) ifelse random-float 1 < pos=0-SAX 
                    [set stay 0][set stay round (random-normal stay-mean-SAX stay-sd-SAX) ]]

if category = "SAW" [set gsize round (random-normal gsize-mean-SAW gsize-sd-SAW) ifelse random-float 1 < pos=0-SAW 
                    [set stay 0][set stay round (random-normal stay-mean-SAW stay-sd-SAW) ]]

if category = "ID" [set gsize round (random-normal gsize-mean-ID gsize-sd-ID)ifelse random-float 1 < pos=0-ID 
                    [set stay 0][set stay round (random-normal stay-mean-ID stay-sd-ID) ]]

if category = "EC" [set gsize round (random-normal gsize-mean-EC gsize-sd-EC)ifelse random-float 1 < pos=0-EC 
                    [set stay 0][set stay round (random-normal stay-mean-EC stay-sd-EC) ]]

if category = "CCW" [set gsize round (random-normal gsize-mean-CCW gsize-sd-CCW) ifelse random-float 1 < pos=0-CCW
                    [set stay 0][set stay round (random-normal stay-mean-CCW stay-sd-CCW) ]]

if category = "CCP" [set gsize round (random-normal gsize-mean-CCP gsize-sd-CCP) ifelse random-float 1 < pos=0-CCP
                    [set stay 0][set stay round (random-normal stay-mean-CCP stay-sd-CCP) ]]

if stay < 0 [set stay 0]
if gsize < 1 [set gsize 1]

if (planning + stay) > (season * 126) [set stay 0]
end

to checkForecastTour

;if category = "SPT" and (ticks = ((126 * (season - 1)) + 1)) and (dest-counter / season) < 3 and random-float 1 < prop-factor
;[set planning (tickstar  + round (random-normal 0 10))]
;
;if category = "SPT" and (ticks != (126 * (season - 1)) + 1) and (dest-counter / season) < 3 and random-float 1 < prop-factor
;[ set planning round (ticks + random-normal 20 10)]

if (ticks mod 5 = 0) [
   
if category = "SAX" and ((dest-counter + ( 15 * creation)) / season) < 15 and random-float 1 < prop-factor [
let m  max [favsnowcover] of xcountries  
if snow-threshold < m   [ ifelse random-float 1 < 0.5 [set planning ticks + 1] [set planning ticks + 2]]]

if any? offpistes with [nlifts = 0][
let m max [favsnowcover] of offpistes with [nlifts = 0]  
if category = "SAW" and snow-threshold < m and avdestsnowsecurity <= 2  and ((dest-counter + ( 15 * creation)) / season) < 15 and random-float 1 < prop-factor
[ ifelse random-float 1 < 0.5 [set planning ticks + 1] [set planning ticks + 2]]]

if any? offpistes with [nlifts > 0][
let m max [favsnowcover] of offpistes with [nlifts > 0]  
if category = "CCW" and snow-threshold < m and ((dest-counter + ( 10 * creation)) / season) < 10 and random-float 1 < prop-factor
[ ifelse random-float 1 < 0.5 [set planning ticks + 1] [set planning ticks + 2]]]
             
                      ] 

if planning < ticks [set planning 0]
;if planning > (126 * (season - 1)) + 126 [set planning 0]
end

to doPlanning

  if category = "TSI" and (ticks = (126 * (season - 1)) + 1) and ((dest-counter + ( 10 * creation)) / season) < 10 and random-float 1 < prop-factor 
  [set planning  round ((126 * (season - 1)) + random-normal 30 20)]                             
 
  if category = "TSI" and (ticks != (126 * (season - 1)) + 1) and ((dest-counter + ( 10 * creation)) / season) < 10 and random-float 1 < prop-factor
  [set planning round (ticks + random-normal 20 10)]
  
  if category = "SPT" and (ticks = (126 * (season - 1)) + 1) and ((dest-counter + ( 2 * creation)) / season) < 2 and random-float 1 < prop-factor
  [set planning  round ((126 * (season - 1)) + random-normal 30 20)]

  if category = "SPT" and (ticks != (126 * (season - 1)) + 1) and ((dest-counter + ( 2 * creation)) / season) < 2 and random-float 1 < prop-factor
  [set planning round (ticks + random-normal 20 10)]

  if category = "ID" and (ticks = (126 * (season - 1)) + 1) and ((dest-counter + ( 2 * creation)) / season) < 2 and random-float 1 < prop-factor
  [set planning round ((126 * (season - 1)) + random-normal 30 20)]
  
  if category = "ID" and (ticks != (126 * (season - 1)) + 1) and ((dest-counter + ( 2 * creation)) / season) < 2 and random-float 1 < prop-factor
  and avdestsnowcover > snow-threshold
  [ set planning round (ticks + random-normal 20 10)]
  
  if (ticks mod 5 = 0) [
  
  if category = "CCP" and ((dest-counter + ( 10 * creation)) / season) < 10 and random-float 1 < prop-factor
  [ifelse random-float 1 < 0.5 [set planning ticks + 1] [set planning ticks + 2]]
  
  if category = "EC" and ((dest-counter + ( 5 * creation)) / season) < 5 and random-float 1 < prop-factor
  [ifelse random-float 1 < 0.5 [set planning ticks + 1] [set planning ticks + 2]]
                  
                       ]

  if planning < ticks [set planning 0]
  ;if planning > (126 * (season - 1)) + 126 [set planning 0]
end  

to enjoyDestination
ask tourists [
if (destination = "yes" and ticks < (planning + stay))   
[ set nagents nagents + 1
  useAccomodations
  useDownHills
  UseXCountries
  useOffPistes
  if any? snowparks [ useSnowParks]
  useOtherFacilities
  useRetailers 
  useRestaurants ]] 
end

to leaveDestination
ask tourists [
if (destination = "yes" and ticks = (planning + stay))   
[ set nagents nagents + 1
  useDownHills
  UseXCountries
  useOffPistes
  if any? snowparks [ useSnowParks]
  useOtherFacilities
  useRetailers 
  useRestaurants
  if myaccomodation != 0 [ let n gsize ask myaccomodation [set users users - n]
                           set myaccomodation 0 ]]]
end

to useDownHills

let c max [kmdownhills] of ski-areas

if category = "TSI" [
  let p random-float 1
  if p < 0.6 [ set mydownhill one-of ([mydownhills] of one-of ski-areas with  [kmdownhills = c ] )  
               set busy "downhill" set expense expense + [price] of mydownhill 
               let n gsize ask mydownhill [set users users + n]] 
  if  (p >= 0.6 and p < 0.9) [ set mydownhill one-of ([mydownhills] of one-of ski-areas with  [kmdownhills != c ] ) 
                               set busy "downhill" set expense expense + [price] of mydownhill 
                               let n gsize ask mydownhill [set users users + n] ]]
if category = "SPT" [
let p random-float 1   
if p < 0.5
[set mydownhill one-of ([mydownhills] of one-of ski-areas with  [kmdownhills = c ] ) 
 set busy "downhill" set expense expense + ([price] of mydownhill * 0.7)
 let n gsize ask mydownhill [set users users + (n / 2)]]
if (p >= 0.5 and p < 0.7)
[set mydownhill one-of ([mydownhills] of one-of ski-areas with  [kmdownhills != c ] ) 
 set busy "downhill" set expense expense + ([price] of mydownhill * 0.7)
 let n gsize ask mydownhill [set users users + (n / 2)]]]

if category = "CCW" and random-float 1 < 0.1 
[set mydownhill (one-of down_hills) set busy "downhill" set expense expense + [price] of mydownhill 
 let n gsize ask mydownhill [set users users + n]]  

if category = "CCP" and random-float 1 < 0.1 
[set mydownhill (one-of down_hills) set busy "downhill" set expense expense + [price] of mydownhill 
 let n gsize ask mydownhill [set users users + n]]  

if  ticks > 126 [
if  DevelopmentStrategy = "Ski Intensive"  or DevelopmentStrategy = "Alternative Ski" [  
if busy = "downhill" [ set myzone ([myzone] of mydownhill)
                         if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                     ifelse myzone = 5 or myzone = 9 [set own-daily-transfer own-daily-transfer + 5]
                                                                                     [set own-daily-transfer own-daily-transfer + 20]]
                                                  if [myzone] of myaccomodation = 3 [   
                                                     ifelse myzone = 5 or myzone = 9 [set own-daily-transfer own-daily-transfer + 50]
                                                                                      [set own-daily-transfer own-daily-transfer + 0]]
                                                  if [myzone] of myaccomodation = 4 [  
                                                     ifelse myzone = 5 or myzone = 9 [set own-daily-transfer own-daily-transfer + 30]
                                                                                     [set own-daily-transfer own-daily-transfer + 10]]]
                         if stay = 0 [ ifelse myzone = 5 or myzone = 9 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 5]
                                                                                                     [set own-daily-transfer own-daily-transfer + 50]]
                                                                       [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 20]
                                                                                                     [set own-daily-transfer own-daily-transfer + 10]]]] ] 

if DevelopmentStrategy = "Beyond Snow" [    
if busy = "downhill" [set myzone ([myzone] of mydownhill)
                      if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [  
                                                    ifelse myzone = 3 [set own-daily-transfer own-daily-transfer + 5]
                                                                      [set own-daily-transfer own-daily-transfer + 50]]
                                                    if [myzone] of myaccomodation = 3 [   
                                                    ifelse myzone = 2 [set own-daily-transfer own-daily-transfer + 50]
                                                                      [set own-daily-transfer own-daily-transfer + 0]]
                                                    if [myzone] of myaccomodation = 4 [  
                                                    ifelse myzone = 1 [set own-daily-transfer own-daily-transfer + 30]
                                                                      [set own-daily-transfer own-daily-transfer + 20]]]
                      if stay = 0 [ ifelse myzone = 5 [ ifelse random-float 1 < 0.8 [set own-daily-transfer 5]
                                                                                    [set own-daily-transfer  own-daily-transfer + 50]]
                                                      [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 50]
                                                                                    [set own-daily-transfer own-daily-transfer + 10]]]] ]] 
if ticks < 127 or DevelopmentStrategy = "BAU"   [    
if busy = "downhill" [set myzone ([myzone] of mydownhill)
                      if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [  
                                                    ifelse myzone = 3 [set own-daily-transfer own-daily-transfer + 5]
                                                                      [set own-daily-transfer own-daily-transfer + 50]]
                                                    if [myzone] of myaccomodation = 3 [   
                                                    ifelse myzone = 2 [set own-daily-transfer own-daily-transfer + 50]
                                                                      [set own-daily-transfer own-daily-transfer + 0]]
                                                    if [myzone] of myaccomodation = 4 [  
                                                    ifelse myzone = 1 [set own-daily-transfer own-daily-transfer + 30]
                                                                      [set own-daily-transfer own-daily-transfer + 20]]]
                      if stay = 0 [ ifelse myzone = 5 [ ifelse random-float 1 < 0.8 [set own-daily-transfer 5]
                                                                                    [set own-daily-transfer  own-daily-transfer + 50]]
                                                      [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 50]
                                                                                    [set own-daily-transfer own-daily-transfer + 10]]]] ] 
end

to useXCountries

if category = "SAX" and busy = "no" [
  let c max [kmtracks] of xcountries
  let p random-float 1
  let n gsize
  if p < 0.7 [ set myxcountry (one-of xcountries with [kmtracks = c]) set busy "xcountry" 
               set expense expense + [price] of myxcountry ask myxcountry [set users users + n]] 
  if  (p >= 0.7 and p < 0.95) [ set myxcountry (one-of xcountries with [kmtracks != c]) set busy "xcountry"
                                 set expense expense + [price] of myxcountry ask myxcountry [set users users + n]]]

if category = "SPT" and busy = "no" and random-float 1 < 0.20 
[set myxcountry (one-of xcountries) set busy "xcountry"  set expense expense + [price] of myxcountry
 let n gsize ask myxcountry [set users users + (n / 2) ]] 

let f max [snowshoes] of xcountries
if snow-shoes = "yes" and busy = "no" and f > 0 [
  let p random-float 1
  let n gsize
  if p < 0.6 [ set myxcountry (one-of xcountries with [snowshoes = f]) set busy "snowshoes"
               set expense expense + [price] of myxcountry ask myxcountry [set users users + n]] 
  if  (p >= 0.6 and p < 0.95) [ set myxcountry (one-of xcountries with [snowshoes != f]) set busy "snowshoes"
                                set expense expense + [price] of myxcountry ask myxcountry [set users users + n]]]

if busy = "xcountry" or busy = "snowshoes" [ set myzone ([myzone] of myxcountry)
                                            if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                                     ifelse myzone = 6 [set own-daily-transfer own-daily-transfer +  30]
                                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                                     if [myzone] of myaccomodation = 3 [   
                                                                     ifelse myzone = 6 [set own-daily-transfer own-daily-transfer + 20]
                                                                                       [set own-daily-transfer own-daily-transfer + 0]]
                                                                     if [myzone] of myaccomodation = 4 [  
                                                                     ifelse myzone = 6 [set own-daily-transfer own-daily-transfer + 0]
                                                                                       [set own-daily-transfer own-daily-transfer + 20]]]
                                                
                                             if stay = 0 [ ifelse myzone = 6 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 30]
                                                                                                           [set own-daily-transfer own-daily-transfer + 20]]
                                                                             [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 50]
                                                                                                           [set own-daily-transfer own-daily-transfer + 10]]]]
end

to useOffPistes 

if any? ski-areas with [free-ride = true] [

if category = "CCW" and busy = "no" and random-float 1 < 0.95 [ 
let c max [kmoffpistes] of ski-areas with [free-ride = true]  
let n gsize
set myoffpiste  (one-of [myoffpistes] of one-of ski-areas with  [kmoffpistes = c ])  set expense expense + [price] of myoffpiste
set busy "offpiste" ask myoffpiste [set users users + n]] 

if category = "TSI" and busy = "no" and random-float 1 < 0.33
[set myoffpiste (one-of offpistes with [nlifts > 0]) set busy "offpiste"  set expense expense + [price] of myoffpiste
 let n gsize ask myoffpiste [set users users + n]]

if category = "SPT" and busy = "no" and random-float 1 < 0.5
[set myoffpiste (one-of offpistes with [nlifts > 0]) set busy "offpiste" set expense expense + [price] of myoffpiste
 let n gsize ask myoffpiste [set users users + (n / 2)]]

if category = "CCP" and busy = "no" and random-float 1 < 0.055
[set myoffpiste (one-of offpistes with [nlifts > 0]) set busy "offpiste" set expense expense + [price] of myoffpiste
 let n gsize ask myoffpiste [set users users + n]]]

if avdestsnowsecurity <= 2 and any? offpistes with [nlifts = 0] and category ="SAW" and busy = "no" and random-float 1 < 0.95
[set myoffpiste (one-of offpistes with [nlifts = 0]) set busy "offpiste" set expense expense + [price] of myoffpiste
 let n gsize ask myoffpiste [set users users + n]]  

if ticks < 126 [
if DevelopmentStrategy = "Ski Intensive"  or DevelopmentStrategy = "Alternative Ski" [
if busy = "offpiste" [ set myzone ([myzone] of myoffpiste)
                       if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                ifelse myzone = 9 [set own-daily-transfer own-daily-transfer +  5]
                                                                  [set own-daily-transfer own-daily-transfer + 20]]
                                                if [myzone] of myaccomodation = 3 [   
                                                ifelse myzone = 9 [set own-daily-transfer own-daily-transfer +  50]
                                                                  [set own-daily-transfer own-daily-transfer + 0]]
                                                if [myzone] of myaccomodation = 4 [  
                                                ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 30]
                                                                  [set own-daily-transfer own-daily-transfer + 10]]]
                         
                         if stay = 0 [ ifelse myzone = 9 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 5]
                                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                         [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 20]
                                                                                       [set own-daily-transfer own-daily-transfer + 10]]]] ]
if DevelopmentStrategy = "Beyond Snow" [
if busy = "offpiste" [ set myzone ([myzone] of myoffpiste)
                       if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 5]
                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                  if [myzone] of myaccomodation = 3 [   
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 50]
                                                                       [set own-daily-transfer own-daily-transfer + 0]]
                                                  if [myzone] of myaccomodation = 4 [  
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 30]
                                                                       [set own-daily-transfer own-daily-transfer + 20]]]
                         
                         if stay = 0 [ ifelse myzone = 9 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 5]
                                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                         [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 50]
                                                                                       [set own-daily-transfer own-daily-transfer + 10]]]] ] ]
if ticks < 127 or DevelopmentStrategy = "BAU"   [
if busy = "offpiste" [ set myzone ([myzone] of myoffpiste)
                       if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 5]
                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                  if [myzone] of myaccomodation = 3 [   
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 50]
                                                                       [set own-daily-transfer own-daily-transfer + 0]]
                                                  if [myzone] of myaccomodation = 4 [  
                                                     ifelse myzone = 9 [set own-daily-transfer own-daily-transfer + 30]
                                                                       [set own-daily-transfer own-daily-transfer + 20]]]
                         
                         if stay = 0 [ ifelse myzone = 9 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 5]
                                                                                       [set own-daily-transfer own-daily-transfer + 50]]
                                                         [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 50]
                                                                                       [set own-daily-transfer own-daily-transfer + 10]]]] ] 
end

to useSnowParks

if category = "CCP" and busy = "no" and random-float 1 < 0.95 [
  let c max [ntricks] of snowparks
  let n gsize
  set mysnowpark (one-of snowparks with [ntricks = c]) set busy "snowpark" set expense expense + [price] of mysnowpark
  ask mysnowpark [set users users + n]]

if category = "SPT" and busy = "no" and random-float 1 < 0.33
[set mysnowpark (one-of snowparks) set busy "snowparks" set expense expense + [price] of mysnowpark
 let n gsize ask mysnowpark [set users users + (n / 2)]]

if category = "CCW" and busy = "no" [
set mysnowpark (one-of snowparks) set busy "snowparks" set expense expense + [price] of mysnowpark
let n gsize ask mysnowpark [set users users + n]]

if category = "TSI" and busy = "no" [
set mysnowpark (one-of snowparks) set busy "snowparks" set expense expense + [price] of mysnowpark
let n gsize ask mysnowpark [set users users + n]]

if busy = "snowparks" [ set myzone ([myzone] of mysnowpark)
 if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                             ifelse myzone = 5 [set own-daily-transfer own-daily-transfer + 5]
                                               [set own-daily-transfer own-daily-transfer + 20]]
                          if [myzone] of myaccomodation = 3 [   
                             ifelse myzone = 5 [set own-daily-transfer own-daily-transfer + 50]
                                               [set own-daily-transfer own-daily-transfer + 0]]
                          if [myzone] of myaccomodation = 4 [  
                             ifelse myzone = 5 [set own-daily-transfer own-daily-transfer + 30]
                                               [set own-daily-transfer own-daily-transfer + 20]]]
                          
if stay = 0 [ ifelse myzone = 5 [ ifelse random-float 1 < 0.8 [set own-daily-transfer own-daily-transfer + 5]
                                                              [set own-daily-transfer own-daily-transfer + 50]]
                                [ ifelse random-float 1 < 0.6 [set own-daily-transfer own-daily-transfer + 20]
                                                              [set own-daily-transfer own-daily-transfer + 10]]]]
end

to useOtherFacilities

if random-float 1 < 0.05 [set mywellness one-of otherfacilities with [category = "wellness" ] set busy "wellness" 
                          set expense expense + [price] of mywellness   
                         let n gsize ask mywellness [set users users + n]]
if random-float 1 < 0.05 [set myothersport one-of otherfacilities with [category = "other-sports" ] set busy "other-sports"
                          set expense expense + [price] of myothersport
                          let n gsize ask myothersport [set users users + n]]

if kids = "yes" and random-float 1 < 0.5 [set mykidsfacility one-of otherfacilities with [category = "kindergarten"]
                                          set expense expense + [price] of mykidsfacility 
                                          let n ((random 2) + 1) ask mykidsfacility [set users users + n]]

if category = "SPT"[
  let p random-float 1
  let n gsize
  if p < 0.1 [set mywellness one-of otherfacilities with [category = "wellness"]  set busy "wellness"  
              set expense expense + [price] of mywellness 
              ask mywellness [set users users + n]]
  if (p >= 0.1 and p < 0.2) [set myothersport one-of otherfacilities with [category = "other-sports"] 
                             set busy "other-sports" set expense expense + [price] of myothersport
                             ask myothersport [set users users + n] ]]

if category = "ID" [
  let p random-float 1
  let n gsize
  if p < 0.1 [set mywellness one-of otherfacilities with [category = "wellness"] set busy "wellness" 
               set expense expense + [price] of mywellness 
               ask mywellness [set users users + n]  ]
  if (p >= 0.1 and p < 0.2) [set myothersport one-of otherfacilities with [category = "other-sports"] set busy "other-sports"
                               set expense expense + [price] of myothersport
                               ask myothersport [set users users + n] ]]

if category = "EC" [
  let p random-float 1
  let n gsize
  if p < 0.4 [set mywellness one-of otherfacilities with [category = "wellness"] set busy "wellness" 
              set expense expense + [price] of mywellness
              ask mywellness [set users users + n] ]
  if (p >= 0.4 and p < 0.8) [set myothersport one-of otherfacilities with [category = "other-sports"] set busy "other-sports"
                             set expense expense + [price] of myothersport
                             ask myothersport [set users users + n] ]]

if busy = "wellness" [set myzone ([myzone] of mywellness)
     if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                     if myzone = 2 [set own-daily-transfer own-daily-transfer + 0]
                                                     if myzone = 3 [set own-daily-transfer own-daily-transfer + 50]
                                                     if myzone = 4 [set own-daily-transfer own-daily-transfer + 30]]
                                                   if [myzone] of myaccomodation = 3 [
                                                     if myzone = 2 [set own-daily-transfer own-daily-transfer + 50]
                                                     if myzone = 3 [set own-daily-transfer own-daily-transfer + 0]
                                                     if myzone = 4 [set own-daily-transfer own-daily-transfer + 20]]
                                                   if [myzone] of myaccomodation = 4 [
                                                     if myzone = 2 [set own-daily-transfer own-daily-transfer + 30]
                                                     if myzone = 3 [set own-daily-transfer own-daily-transfer + 20]
                                                     if myzone = 4 [set own-daily-transfer own-daily-transfer + 0]]]]


 if busy = "other-sports" [set myzone ([myzone] of myothersport)
     if myaccomodation != 0 [ if [myzone] of myaccomodation = 2 [
                                                       if myzone = 2 [set own-daily-transfer own-daily-transfer + 0]
                                                       if myzone = 3 [set own-daily-transfer own-daily-transfer + 50]
                                                       if myzone = 4 [set own-daily-transfer own-daily-transfer + 30]]
                                                   if [myzone] of myaccomodation = 3 [
                                                       if myzone = 2 [set own-daily-transfer own-daily-transfer + 50]
                                                       if myzone = 3 [set own-daily-transfer own-daily-transfer + 0]
                                                       if myzone = 4 [set own-daily-transfer own-daily-transfer + 20]]
                                                   if [myzone] of myaccomodation = 4 [
                                                       if myzone = 2 [set own-daily-transfer own-daily-transfer + 30]
                                                       if myzone = 3 [set own-daily-transfer own-daily-transfer + 20]
                                                       if myzone = 4 [set own-daily-transfer own-daily-transfer + 0]]]] 

end

to useRetailers

if category = "TSI"[
  if random-float 1 < 0.7 [set mybar one-of retailers with [category = "bars"] set expense expense + [price] of mybar
                           let n gsize ask mybar [set users users + n]]]

if category = "EC" [
  if random-float 1 < 0.7 [set mybar one-of retailers with [category = "bars"] set expense expense + [price] of mybar
                           let n gsize ask mybar [set users users + n]]
  if random-float 1 < 0.25 [set myclothes one-of retailers with [category = "clothes"] set expense expense + [price] of myclothes
                            let n gsize ask myclothes [set users users + n]]
  if random-float 1 < 0.25 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                            let n gsize ask myfood [set users users + n]]
  if random-float 1 < 0.25 [set mysouvenirs one-of retailers with [category = "souvenirs"] set expense expense + [price] of mysouvenirs
                            let n gsize ask mysouvenirs [set users users + n]]]

if category = "CCW" [
  if random-float 1 < 0.7 [set mybar one-of retailers with [category = "bars"] set expense expense + [price] of mybar
                           let n gsize ask mybar [set users users + n]]
  if random-float 1 < 0.65 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                            let n gsize ask myfood [set users users + n]]]
  
if category = "CCP" [
  if random-float 1 < 0.7 [set mybar one-of retailers with [category = "bars"] set expense expense + [price] of mybar
                           let n gsize ask mybar [set users users + n]]
  if random-float 1 < 0.65 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                            let n gsize ask myfood [set users users + n]]]

if category = "ID" [
  if random-float 1 < 0.8 [set mybar one-of retailers with [category = "bars"] set expense expense + [price] of mybar
                            let n gsize ask mybar [set users users + n]]
  if random-float 1 < 0.25 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                            let n gsize ask myfood [set users users + n]]
  if random-float 1 < 0.15 [set myclothes one-of retailers with [category = "clothes"] set expense expense + [price] of myclothes
                            let n gsize ask myclothes [set users users + n]]
  if random-float 1 < 0.15 [set mysouvenirs one-of retailers with [category = "souvenirs"] set expense expense + [price] of mysouvenirs
                            let n gsize ask mysouvenirs [set users users + n]]]

if category = "SPT" [
  if random-float 1 < 0.5 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                           let n gsize ask myfood [set users users + n]]]

if category = "SAW" [
  if random-float 1 < 0.8 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                           let n gsize ask myfood [set users users + n] ]]

if category = "SAX" [
  if random-float 1 < 0.8 [set myfood one-of retailers with [category = "food"] set expense expense + [price] of myfood
                           let n gsize ask myfood [set users users + n]]]
end  

to useRestaurants

if category = "ID" [
  let p random-float 1
  if p < 0.2 [set myrestaurant one-of restaurants with [category = "low-cost" ] set expense expense + [price] of myrestaurant
              let n gsize ask myrestaurant [set users users + n]]
  if (p >= 0.2 and p < 0.4) [set myrestaurant one-of restaurants with [category = "medium-cost" ] set expense expense + [price] of myrestaurant
                             let n gsize ask myrestaurant [set users users + n]]
  if (p >= 0.4 and p < 0.6) [set myrestaurant one-of restaurants with [category = "high-cost" ] set expense expense + [price] of myrestaurant
                             let n gsize ask myrestaurant [set users users + n]]]
  
if category = "CCW" [
  let p1 random-float 1
  if p1 < 0.2 [set myrestaurant one-of restaurants with [category = "low-cost" ]  set expense expense + [price] of myrestaurant
               let n gsize ask myrestaurant [set users users + n] ]
  if (p1 >= 0.2 and p1 < 0.4) [set myrestaurant one-of restaurants with [category = "medium-cost" ] set expense expense + [price] of myrestaurant
                               let n gsize ask myrestaurant [set users users + n]]
  if (p1 >= 0.4 and p1 < 0.6) [set myrestaurant one-of restaurants with [category = "high-cost" ] set expense expense + [price] of myrestaurant
                               let n gsize ask myrestaurant [set users users + n]]]  

if category = "CCP" [
  let p2 random-float 1
  if p2 < 0.2 [set myrestaurant one-of restaurants with [category = "low-cost" ] set expense expense + [price] of myrestaurant
               let n gsize ask myrestaurant [set users users + n]]
  if (p2 >= 0.2 and p2 < 0.4) [set myrestaurant one-of restaurants with [category = "medium-cost" ] set expense expense + [price] of myrestaurant
                               let n gsize ask myrestaurant [set users users + n]]
  if (p2 >= 0.4 and p2 < 0.6) [set myrestaurant one-of restaurants with [category = "high-cost" ] set expense expense + [price] of myrestaurant
                               let n gsize ask myrestaurant [set users users + n]]]  

if category = "EC" [
  let p3 random-float 1
  if p3 < 0.25 [set myrestaurant one-of restaurants with [category = "low-cost" ] set expense expense + [price] of myrestaurant
                let n gsize ask myrestaurant [set users users + n] ]
  if (p3 >= 0.25 and p3 < 0.5) [set myrestaurant one-of restaurants with [category = "medium-cost"] set expense expense + [price] of myrestaurant
                                let n gsize ask myrestaurant [set users users + n]]
  if (p3 >= 0.25 and p3 < 0.75) [set myrestaurant one-of restaurants with [category = "high-cost" ] set expense expense + [price] of myrestaurant
                                 let n gsize ask myrestaurant [set users users + n]]]  
  
if category = "TSI" [
  let p4 random-float 1
  
  if p4 < 0.25 [set myrestaurant one-of restaurants with [category = "low-cost" ] 
                set expense expense + [price] of myrestaurant
                let n gsize ask myrestaurant [set users users + n]]
  if (p4 >= 0.25 and p4 < 0.5) [set myrestaurant one-of restaurants with [category = "medium-cost" ] 
                                set expense expense + [price] of myrestaurant
                                let n gsize ask myrestaurant [set users users + n]]
  if (p4 >= 0.25 and p4 < 0.75) [set myrestaurant one-of restaurants with [category = "high-cost" ] 
                                 set expense expense + [price] of myrestaurant
                                 let n gsize ask myrestaurant [set users users + n]]]    
  
if category = "SPT" [
  let p5 random-float 1
  if p5 < 0.2 [set myrestaurant one-of restaurants with [category = "medium-cost" ] set expense expense + [price] of myrestaurant
               let n gsize ask myrestaurant [set users users + n]]]

if category = "SAX" [
  let p5 random-float 1
  if p5 < 0.1 [set myrestaurant one-of restaurants with [category = "low-cost" ] set expense expense + [price] of myrestaurant
               let n gsize ask myrestaurant [set users users + n]]]

if category = "SAW" [
  let p6 random-float 1
  if p6 < 0.1 [set myrestaurant one-of restaurants with [category = "low-cost" ] set expense expense + [price] of myrestaurant
               let n gsize ask myrestaurant [set users users + n]  ]
  if (p6 >= 0.1 and p6 < 0.2) [set myrestaurant one-of restaurants with [category = "medium-cost" ] set expense expense + [price] of myrestaurant
                               let n gsize ask myrestaurant [set users users + n]]]   
  
end


to useAccomodations


if category = "ID" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.2 [set myaccomodation one-of accomodations with [category = "extrahotels" ] 
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n]  ]
  if (p >= 0.2 and p < 0.6) [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
                             set expense expense + [price] of myaccomodation
                             let n gsize ask myaccomodation [set users users + n]   ]
  if p >= 0.6 [set myaccomodation one-of accomodations with [category = "three-four-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "CCW" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.3 [set myaccomodation one-of accomodations with [category = "extrahotels" ]
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n]  ]
  if (p >= 0.3 and p < 0.7) [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
                             set expense expense + [price] of myaccomodation
                             let n gsize ask myaccomodation [set users users + n]]
  if p >= 0.7 [set myaccomodation one-of accomodations with [category = "three-four-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "CCP" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.3 [set myaccomodation one-of accomodations with [category = "extrahotels" ]
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n]  ]
  if (p >= 0.3 and p < 0.7) [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
                             set expense expense + [price] of myaccomodation
                             let n gsize ask myaccomodation [set users users + n]]
  if p >= 0.7 [set myaccomodation one-of accomodations with [category = "three-four-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "EC" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.2 [set myaccomodation one-of accomodations with [category = "extrahotels" ]
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n]  ]
  if (p >= 0.5 and p < 0.5) [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
                             set expense expense + [price] of myaccomodation
                             let n gsize ask myaccomodation [set users users + n]]
  if p >= 0.5 [set myaccomodation one-of accomodations with [category = "three-four-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "TSI" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.5 [set myaccomodation one-of accomodations with [category = "extrahotels" ]
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n]  ]
  if (p >= 0.5 and p < 0.9) [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
                             set expense expense + [price] of myaccomodation
                             let n gsize ask myaccomodation [set users users + n]]
  if p >= 0.9 [set myaccomodation one-of accomodations with [category = "three-four-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "SAW" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.8 [set myaccomodation one-of accomodations with [category = "extrahotels"] 
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n] ]
  if p >= 0.8 [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "SAX" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.8 [set myaccomodation one-of accomodations with [category = "extrahotels" ] 
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n] ]
  if p >= 0.8 [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

if category = "SPT" and myaccomodation = 0 [
  let p random-float 1
  if p < 0.8 [set myaccomodation one-of accomodations with [category = "extrahotels" ] 
              set expense expense + [price] of myaccomodation
              let n gsize ask myaccomodation [set users users + n] ]
  if p >= 0.8 [set myaccomodation one-of accomodations with [category = "one-two-stars" ]
               set expense expense + [price] of myaccomodation
               let n gsize ask myaccomodation [set users users + n]]]

end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;end of behavioural part

;;;;;;;;;; closing procedures

to updateUsers_8

ask down_hills [  
  set occupation-rate (users / CCC)
  set density users / count mypatches                         
  let d density
  ask mypatches [set occupation (occupation + d)]]

ask xcountries [ 
  set occupation-rate (users / CCC)
  set density users / count mypatches
  let d density
  ask mypatches [set occupation (occupation + d)]]

if any? snowparks  [ask snowparks [ 
  set occupation-rate (users / CCC)
  set density users / count mypatches
  let d density
  ask mypatches [set occupation (occupation + d)]]]

ask offpistes [ 
  set occupation-rate (users / CCC)
  set density users / count mypatches
  let d density
  ask mypatches [set occupation (occupation + d)]]

ask accomodations [  
  let u users
  set occupation-rate (u / nbeds)
  ask mypatch [set occupation (occupation + u)]]

ask restaurants [ 
  let u users
  set occupation-rate (u / ncovers)
  ask mypatch [set occupation (occupation + u)]]

ask otherfacilities with [category = "kindergarten"] [ 
  let u users
  set occupation-rate (u / CCC)
  ask mypatch [set occupation (occupation + u)]]

ask otherfacilities with [category = "wellness"] [ 
  let u users
  set occupation-rate (u / CCC)
  ask mypatch [set occupation (occupation + u)]]

ask otherfacilities with [category = "other-sports"] [
  let u users
  set occupation-rate (u / CCC)
  ask mypatch [set occupation (occupation + u)]]

ask retailers with [category = "bar"][ 
  let u users
  ask mypatch [set occupation (occupation + u)]]

ask retailers with [category = "clothes"][ 
  let u users
  ask mypatch [set occupation (occupation + u)]]

ask retailers with [category = "food"][
  let u users
  ask mypatch [set occupation (occupation + u)]]

ask retailers with [category = "souvenirs"][ 
  let u users
  ask mypatch [set occupation (occupation + u)]]

plot-occupation
end

to checkOccupation

;let a max [occupation] of patches                           ; weighted not average
;ask patches [let b (occupation / a)
;             if (b >= 0.8) [set pcolor red]
;             if (b < 0.8 and b >= 0.6) [set pcolor orange]
;             if (b < 0.6 and b >= 0.4) [set pcolor yellow]
;             if (b < 0.4 and b >= 0.2) [set pcolor violet]
;             if (b < 0.2 and b >= 0.1) [set pcolor blue]
;             if (b < 0.1 and b >= 0.0) [set pcolor black  ]]

;ask patches [ let n (ticks - (42 * int ((ticks - 1) / 42)))   ;weighted average
;              set avOcc ((((n - 1) * avOcc) + occupation) / n)
;             
;             if ( ticks mod 42) = 0 [             
;             let a max [avOcc] of patches
;             if a > 0 [let b (avOcc / a)
;             if (b >= 0.8) [set pcolor red]
;             if (b < 0.8 and b >= 0.6) [set pcolor orange]
;             if (b < 0.6 and b >= 0.4) [set pcolor yellow]
;             if (b < 0.4 and b >= 0.2) [set pcolor violet]
;             if (b < 0.2 and b >= 0.1) [set pcolor sky]
;             if (b < 0.1 and b >= 0.0) [set pcolor blue]
;             if area = 0 [set pcolor black]
;             if area = 1 [set pcolor white]
;             ]] ]
;
;if (ticks mod 63 = 0) [visualize-land]

end

to calcExpense

if any? tourists with [destination = "yes"] [set avExpense mean [expense] of tourists with [destination = "yes"]]
let n (ticks - (126 * int ((ticks - 1) / 126)))  
set CUMavExpense ((((n - 1) * CUMavExpense) + avExpense) / n)
if ticks mod 126 = 1 [set CUMavExpense 0]

if any? tourists with [destination = "yes" and category = "TSI"] 
[set avExpenseTSI mean [expense] of tourists with [destination = "yes" and category = "TSI"]]
if any? tourists with [destination = "yes" and category = "SPT"]
[set avExpenseSPT mean [expense] of tourists with [destination = "yes" and category = "SPT"]]
if any? tourists with [destination = "yes" and category = "ID"]
[set avExpenseID mean [expense] of tourists with [destination = "yes" and category = "ID"]]
if any? tourists with [destination = "yes" and category = "EC"]
[set avExpenseEC mean [expense] of tourists with [destination = "yes" and category = "EC"]]
if any? tourists with [destination = "yes" and category = "SAX"]
[set avExpenseSAX mean [expense] of tourists with [destination = "yes" and category = "SAX"]]
if any? tourists with [destination = "yes" and category = "SAW"]
[set avExpenseSAW mean [expense] of tourists with [destination = "yes" and category = "SAW"]]
if any? tourists with [destination = "yes" and category = "CCW"]
[set avExpenseCCW mean [expense] of tourists with [destination = "yes" and category = "CCW"]]
if any? tourists with [destination = "yes" and category = "CCP"]
[set avExpenseCCP mean [expense] of tourists with [destination = "yes" and category = "CCP"]]

set-current-plot "Daily Expense $"
set-current-plot-pen "TOT"
plot avExpense 
set-current-plot-pen "TSI"
plot avExpenseTSI
set-current-plot-pen "SPT" 
plot avExpenseSPT
set-current-plot-pen "SAX"
plot avExpenseSAX
set-current-plot-pen "SAW"
plot avExpenseSAW
set-current-plot-pen "CCP"
plot avExpenseCCP
set-current-plot-pen "CCW"
plot avExpenseCCW
set-current-plot-pen "ID"
plot avExpenseID
set-current-plot-pen "EC"
plot avExpenseEC
 
end  

to updateNVistors

;set potentials potentials + (sum [gsize] of tourists with [potential = "yes"])
  

set nOvernightVisitors  nOvernightVisitors + (sum [gsize] of tourists with [ destination = "yes" and myaccomodation != 0])

set nTSI (sum [gsize] of tourists with [destination = "yes" and category = "TSI"])
set nSPT (sum [gsize] of tourists with [destination = "yes" and category = "SPT"])
set nSax (sum [gsize] of tourists with [destination = "yes" and category = "SAX"])
set nSAW (sum [gsize] of tourists with [destination = "yes" and category = "SAW"])
set nCCP (sum [gsize] of tourists with [destination = "yes" and category = "CCP"])
set nCCW (sum [gsize] of tourists with [destination = "yes" and category = "CCW"])
set nEC  (sum [gsize] of tourists with [destination = "yes" and category = "EC"])
set nID  (sum [gsize] of tourists with [destination = "yes" and category = "ID"])

set nVisitors ntsi + nspt + nsax + nsaw + nccp + nccw + nec + nid
set Vlist lput nvisitors Vlist

If nvisitors != 0 [set mean-gsize nvisitors / nagents
                   set indivDailyTransfer (dailytransfer * mean-gsize / nvisitors)] 

set CnTSI CnTSI + nTSI
set CnSPT CnSPT + nSPT
set CnSAX CnSAX + nSAX
set CnSAW CnSAW + nSAW
set CnCCP CnCCP + nCCP
set CnCCW CnCCW + nCCW
set CnEC  CnEC + nEC
set CnID  CnID + nID
set CnVisitors Cntsi + Cnspt + Cnsax + Cnsaw + Cnccp + Cnccw + Cnec + Cnid

set DailyTransfer sum [own-daily-transfer] of tourists
set TotCumTransfer DailyTransfer + TotCumTransfer

plot-visitors

plot-CUMvisitors

plot-arrivals

if (ticks mod 126) = 1 [  set Cnvisitors 0 set Cntsi 0 set Cnspt 0 set Cnccw 0 set Cnccp 0 set Cnid 0 set Cnec 0 set Cnsax 0 set Cnsaw 0
                      set nOvernightVisitors 0 set arrivals 0  set TotCumTransfer 0]
if (ticks mod 126) = 0 [set sigma standard-deviation Vlist
                      set mu mean Vlist
                      set VarCo (sigma / mu)
                      set Vlist [ ]]

end

to calcSatisfaction

ask tourists with [destination = "yes"] [

if busy = "downhill" [
              ifelse  ([avSnowCover] of mydownhill > 0.5 * snow-threshold) and ([occupation-rate] of mydownhill < 2)
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "xcountry" [
              ifelse (([avSnowCover] of myxcountry > 0.5 * snow-threshold) and ([occupation-rate] of myxcountry < 2)) 
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "offpiste" [
              ifelse (([avSnowCover] of myoffpiste > 0.5 * snow-threshold) and ([occupation-rate] of myoffpiste < 2)) 
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "snowpark" [
              ifelse (([avSnowCover] of mysnowpark > 0.5 * snow-threshold) and ([occupation-rate] of mysnowpark < 2)) 
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "wellness" [
              ifelse ([occupation-rate] of mywellness < 2) 
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "other-sports" [
              ifelse ([occupation-rate] of myothersport < 2) 
              [ set satisfaction (satisfaction + 1) ] [set satisfaction ( satisfaction - 1)]]

if busy = "no" [ set satisfaction (satisfaction + 1) ]
                                           ]

end

to updateSatisfaction

ask tourists with [destination = "yes" ] [
                   if ((ticks = planning + stay) and (satisfaction <= 0)) [
                   if category = "TSI"  [set deadTSI (deadTSI + 1)  set usTSI (usTSI + gsize) die] 
                   if category = "SPT"  [set deadSPT (deadSPT + 1)  set usSPT (usSPT + gsize) die]
                   if category = "SAX"  [set deadSAX (deadSAX + 1)  set usSAX (usSAX + gsize) die]
                   if category = "SAW"  [set deadSAW (deadSAW + 1)  set usSAW (usSAW + gsize) die]
                   if category = "CCW"  [set deadCCW (deadCCW + 1)  set usCCW (usCCW + gsize) die]
                   if category = "CCP"  [set deadCCP (deadCCP + 1)  set usCCP (usCCP + gsize) die]
                   if category = "ID"   [set deadID (deadID + 1)    set usID (usID + gsize) die]
                   if category = "EC"   [set deadEC (deadEC + 1)    set usEC (usEC + gsize) die]]]
                   
set usTOT (usTSI + usSPT + usSAX + usSAW + usCCW + usCCW + usCCP + usID + usEC)
plot-dead

if ( ticks mod 126) = 0 [ask tourists [set planning 0]
                         create-new-tourists
                         set deadTSI 0 set deadSPT 0 set deadSAX 0 set deadSAW 0
                         set deadCCW 0 set deadCCP 0 set deadID 0 set deadEC 0   
                         set usTSI 0 set usSPT 0 set usSAX 0 set usSAW 0
                         set usCCW 0 set usCCP 0 set usID 0 set usEC 0 ]
end




;;;;;;;;;;;;;;;;;;;;;
to create-new-tourists

let n (deadTSI + deadSPT + deadSAX + deadSAW + deadCCW + deadCCP + deadID + deadEC)
set xx ticks / 126

create-tourists n [set category "nil" set busy "no" set gsize 0 set kids "no"  set potential "no" set destination "no" set planning 0 
                   set stay 0 set satisfaction 0 set creation xx set dest-counter 0  
                   set  myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0
                   set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0 set myAccomodation 0]

 ask n-of (deadTSI) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "TSI" 
   set KM-threshold random-normal KM-threshold-mean-TSI KM-threshold-sd-TSI
   set kids-prob random-normal kids-prob-mean-TSI kids-prob-sd-TSI
   set snow-shoes-prob random-normal snow-shoes-prob-mean-TSI snow-shoes-prob-sd-TSI
   set snow-threshold random-normal snow-threshold-mean-TSI  snow-threshold-sd-TSI]
 
 ask n-of (deadSPT) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "SPT" 
   set KM-threshold random-normal  KM-threshold-mean-SPT KM-threshold-sd-SPT
   set Nature-threshold  random-normal Nature-threshold-mean-SPT Nature-threshold-sd-SPT
   set kids-prob random-normal kids-prob-mean-SPT kids-prob-sd-SPT
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SPT snow-shoes-prob-sd-SPT
   set snow-threshold random-normal snow-threshold-mean-SPT snow-threshold-sd-SPT] 
 
 ask n-of (deadSAW) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "SAW" 
   set KM-threshold random-normal KM-threshold-mean-SAW KM-threshold-sd-SAW 
   set Nature-threshold  random-normal Nature-threshold-mean-SAW Nature-threshold-sd-SAW
   set kids-prob random-normal kids-prob-mean-SAW kids-prob-sd-SAW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAW snow-shoes-prob-sd-SAW
   set snow-threshold random-normal snow-threshold-mean-SAW snow-threshold-sd-SAW] 
  
 ask n-of (deadSAX) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "SAX"  
   set KM-threshold random-normal KM-threshold-mean-SAX KM-threshold-sd-SAX  
   set Nature-threshold random-normal Nature-threshold-mean-SAX Nature-threshold-sd-SAX
   set kids-prob  random-normal kids-prob-mean-SAX kids-prob-sd-SAX 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAX snow-shoes-prob-sd-SAX
   set snow-threshold random-normal snow-threshold-mean-SAX snow-threshold-sd-SAX] 

 ask n-of (deadID) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "ID"  
   set Nature-threshold  random-normal Nature-threshold-mean-ID Nature-threshold-sd-ID
   set kids-threshold random-normal kids-threshold-mean-ID kids-threshold-sd-ID 
   set wellness-threshold random-normal wellness-threshold-mean-ID wellness-threshold-sd-ID
   set kids-prob  random-normal kids-prob-mean-ID kids-prob-sd-ID  
   set snow-shoes-prob random-normal snow-shoes-prob-mean-ID snow-shoes-prob-sd-ID
   set snow-threshold random-normal snow-threshold-mean-ID snow-threshold-sd-ID]
                                                                                                                                          
 ask n-of (deadEC) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "EC" 
   set sports-threshold random-normal sports-threshold-mean-EC sports-threshold-sd-EC
   set wellness-threshold random-normal  wellness-threshold-mean-EC wellness-threshold-sd-EC
   set qualityhotels-threshold random-normal qualityhotels-threshold-mean-EC qualityhotels-threshold-sd-EC
   set boutiques-threshold random-normal boutiques-threshold-mean-EC boutiques-threshold-sd-EC
   set kids-prob  random-normal kids-prob-mean-EC kids-prob-sd-EC 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-EC snow-shoes-prob-sd-EC
   set snow-threshold random-normal snow-threshold-mean-EC snow-threshold-sd-EC ]
 
 ask n-of (deadCCW) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "CCW"
   set KM-threshold random-normal KM-threshold-mean-CCW KM-threshold-sd-CCW 
   set Nature-threshold  random-normal Nature-threshold-mean-CCW Nature-threshold-sd-CCW
   set kids-prob  random-normal kids-prob-mean-CCW kids-prob-sd-CCW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCW snow-shoes-prob-sd-CCW
   set snow-threshold random-normal snow-threshold-mean-CCW snow-threshold-sd-CCW ]
 
 ask n-of (deadCCP) tourists  with [creation = xx and category = "nil" ]  [ 
   set category "CCP" 
   set tricks-threshold random-normal tricks-threshold-mean-CCP tricks-threshold-sd-CCP 
   set kids-prob random-normal kids-prob-mean-CCP kids-prob-sd-CCP 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCP snow-shoes-prob-sd-CCP
   set snow-threshold random-normal snow-threshold-mean-CCP snow-threshold-sd-CCP ] 
     

 

if ClimateScenario = "Baseline80-00" and count tourists < 9000 [
  
let m (5800 + (230 * (season + 1)) - count tourists )  

create-tourists m [set category "nil" set busy "no" set gsize 0 set kids "no"  set potential "no" set destination "no" set planning 0 
                   set stay 0 set satisfaction 0 set creation xx set dest-counter 0  
                   set  myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0
                   set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0 set myAccomodation 0]
 
let na count tourists with [ creation = xx and category = "nil"] 
 
  ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "TSI" 
   set KM-threshold random-normal KM-threshold-mean-TSI KM-threshold-sd-TSI
   set kids-prob random-normal kids-prob-mean-TSI kids-prob-sd-TSI
   set snow-shoes-prob random-normal snow-shoes-prob-mean-TSI snow-shoes-prob-sd-TSI
   set snow-threshold random-normal snow-threshold-mean-TSI snow-threshold-sd-TSI] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "SPT" 
   set KM-threshold random-normal  KM-threshold-mean-SPT KM-threshold-sd-SPT
   set Nature-threshold  random-normal Nature-threshold-mean-SPT Nature-threshold-sd-SPT
   set kids-prob random-normal kids-prob-mean-SPT kids-prob-sd-SPT
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SPT snow-shoes-prob-sd-SPT
   set snow-threshold random-normal snow-threshold-mean-SPT snow-threshold-sd-SPT] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [
   set category "SAW" 
   set KM-threshold random-normal KM-threshold-mean-SAW KM-threshold-sd-SAW 
   set Nature-threshold  random-normal Nature-threshold-mean-SAW Nature-threshold-sd-SAW
   set kids-prob random-normal kids-prob-mean-SAW kids-prob-sd-SAW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAW snow-shoes-prob-sd-SAW
   set snow-threshold random-normal snow-threshold-mean-SAW snow-threshold-sd-SAW] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "SAX" 
   set KM-threshold random-normal KM-threshold-mean-SAX KM-threshold-sd-SAX  
   set Nature-threshold random-normal Nature-threshold-mean-SAX Nature-threshold-sd-SAX
   set kids-prob  random-normal kids-prob-mean-SAX kids-prob-sd-SAX 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAX snow-shoes-prob-sd-SAX
   set snow-threshold random-normal snow-threshold-mean-SAX snow-threshold-sd-SAX] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "ID"  
   set Nature-threshold  random-normal Nature-threshold-mean-ID Nature-threshold-sd-ID
   set kids-threshold random-normal kids-threshold-mean-ID kids-threshold-sd-ID 
   set wellness-threshold random-normal wellness-threshold-mean-ID wellness-threshold-sd-ID
   set kids-prob  random-normal kids-prob-mean-ID kids-prob-sd-ID  
   set snow-shoes-prob random-normal snow-shoes-prob-mean-ID snow-shoes-prob-sd-ID
   set snow-threshold random-normal snow-threshold-mean-ID snow-threshold-sd-ID] 
                                                                                                                                          
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "EC"  
   set sports-threshold random-normal sports-threshold-mean-EC sports-threshold-sd-EC
   set wellness-threshold random-normal  wellness-threshold-mean-EC wellness-threshold-sd-EC
   set qualityhotels-threshold random-normal qualityhotels-threshold-mean-EC qualityhotels-threshold-sd-EC
   set boutiques-threshold random-normal boutiques-threshold-mean-EC boutiques-threshold-sd-EC
   set kids-prob  random-normal kids-prob-mean-EC kids-prob-sd-EC 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-EC snow-shoes-prob-sd-EC
   set snow-threshold random-normal snow-threshold-mean-EC snow-threshold-sd-EC] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "CCW" 
   set KM-threshold random-normal KM-threshold-mean-CCW KM-threshold-sd-CCW 
   set Nature-threshold  random-normal Nature-threshold-mean-CCW Nature-threshold-sd-CCW
   set kids-prob  random-normal kids-prob-mean-CCW kids-prob-sd-CCW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCW snow-shoes-prob-sd-CCW
   set snow-threshold random-normal snow-threshold-mean-CCW snow-threshold-sd-CCW] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "CCP" 
   set tricks-threshold random-normal tricks-threshold-mean-CCP tricks-threshold-sd-CCP 
   set kids-prob random-normal kids-prob-mean-CCP kids-prob-sd-CCP 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCP snow-shoes-prob-sd-CCP
   set snow-threshold random-normal snow-threshold-mean-CCP snow-threshold-sd-CCP] 

 ask tourists with [category = "nil"] [die]
 
  ] 
  
if ClimateScenario != "Baseline80-00" and SocietalScenario = "Optimistic" and count tourists < 14000 [
  
let m (11000 + (230 * (season + 1)) - count tourists )  

create-tourists m [set category "nil" set busy "no" set gsize 0 set kids "no"  set potential "no" set destination "no" set planning 0 
                   set stay 0 set satisfaction 0 set creation xx set dest-counter 0  
                   set  myDownHill 0 set myXCountry 0 set myOffPiste 0 set mySnowPark 0 set myOtherSport 0 set myKidsFacility 0
                   set myWellness  0 set myBar 0  set myFood 0 set myClothes 0 set mySouvenirs 0 set myRestaurant 0 set myAccomodation 0]
 
let na count tourists with [ creation = xx and category = "nil"] 
 
  ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "TSI" 
   set KM-threshold random-normal KM-threshold-mean-TSI KM-threshold-sd-TSI
   set kids-prob random-normal kids-prob-mean-TSI kids-prob-sd-TSI
   set snow-shoes-prob random-normal snow-shoes-prob-mean-TSI snow-shoes-prob-sd-TSI
   set snow-threshold random-normal snow-threshold-mean-TSI snow-threshold-sd-TSI] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "SPT" 
   set KM-threshold random-normal  KM-threshold-mean-SPT KM-threshold-sd-SPT
   set Nature-threshold  random-normal Nature-threshold-mean-SPT Nature-threshold-sd-SPT
   set kids-prob random-normal kids-prob-mean-SPT kids-prob-sd-SPT
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SPT snow-shoes-prob-sd-SPT
   set snow-threshold random-normal snow-threshold-mean-SPT snow-threshold-sd-SPT] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [
   set category "SAW" 
   set KM-threshold random-normal KM-threshold-mean-SAW KM-threshold-sd-SAW 
   set Nature-threshold  random-normal Nature-threshold-mean-SAW Nature-threshold-sd-SAW
   set kids-prob random-normal kids-prob-mean-SAW kids-prob-sd-SAW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAW snow-shoes-prob-sd-SAW
   set snow-threshold random-normal snow-threshold-mean-SAW snow-threshold-sd-SAW] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "SAX" 
   set KM-threshold random-normal KM-threshold-mean-SAX KM-threshold-sd-SAX  
   set Nature-threshold random-normal Nature-threshold-mean-SAX Nature-threshold-sd-SAX
   set kids-prob  random-normal kids-prob-mean-SAX kids-prob-sd-SAX 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-SAX snow-shoes-prob-sd-SAX
   set snow-threshold random-normal snow-threshold-mean-SAX snow-threshold-sd-SAX] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"] [ 
   set category "ID"  
   set Nature-threshold  random-normal Nature-threshold-mean-ID Nature-threshold-sd-ID
   set kids-threshold random-normal kids-threshold-mean-ID kids-threshold-sd-ID 
   set wellness-threshold random-normal wellness-threshold-mean-ID wellness-threshold-sd-ID
   set kids-prob  random-normal kids-prob-mean-ID kids-prob-sd-ID  
   set snow-shoes-prob random-normal snow-shoes-prob-mean-ID snow-shoes-prob-sd-ID
   set snow-threshold random-normal snow-threshold-mean-ID snow-threshold-sd-ID] 
                                                                                                                                          
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "EC"  
   set sports-threshold random-normal sports-threshold-mean-EC sports-threshold-sd-EC
   set wellness-threshold random-normal  wellness-threshold-mean-EC wellness-threshold-sd-EC
   set qualityhotels-threshold random-normal qualityhotels-threshold-mean-EC qualityhotels-threshold-sd-EC
   set boutiques-threshold random-normal boutiques-threshold-mean-EC boutiques-threshold-sd-EC
   set kids-prob  random-normal kids-prob-mean-EC kids-prob-sd-EC 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-EC snow-shoes-prob-sd-EC
   set snow-threshold random-normal snow-threshold-mean-EC snow-threshold-sd-EC] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "CCW" 
   set KM-threshold random-normal KM-threshold-mean-CCW KM-threshold-sd-CCW 
   set Nature-threshold  random-normal Nature-threshold-mean-CCW Nature-threshold-sd-CCW
   set kids-prob  random-normal kids-prob-mean-CCW kids-prob-sd-CCW 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCW snow-shoes-prob-sd-CCW
   set snow-threshold random-normal snow-threshold-mean-CCW snow-threshold-sd-CCW] 
 
 ask n-of int (0.125 * na) tourists with [ creation = xx and category = "nil"]  [ 
   set category "CCP" 
   set tricks-threshold random-normal tricks-threshold-mean-CCP tricks-threshold-sd-CCP 
   set kids-prob random-normal kids-prob-mean-CCP kids-prob-sd-CCP 
   set snow-shoes-prob random-normal snow-shoes-prob-mean-CCP snow-shoes-prob-sd-CCP
   set snow-threshold random-normal snow-threshold-mean-CCP snow-threshold-sd-CCP] 

 ask tourists with [category = "nil"] [die]
 
  ]  
  
  
 ask tourists with [creation = xx] [ifelse (random-float 1 < kids-prob) [set kids "yes"] [set kids "no"]
    ifelse (random-float 1 < snow-shoes-prob) [set snow-shoes "yes"] [set snow-shoes "no"]
    set hidden? true] 
 
 set-comp&prop-factor
 
end  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; end of closing procedure
;Plotting

to plot-dead

set-current-plot "Unsatisfied Tourists"
set-current-plot-pen "TSI"
plot usTSI 
set-current-plot-pen "SPT"
plot usSPT
set-current-plot-pen "SAX"
plot usSAX
set-current-plot-pen "SAW"
plot usSAW  
set-current-plot-pen "CCP"
plot usCCP
set-current-plot-pen "CCW"
plot usCCW
set-current-plot-pen "ID"
plot usID
set-current-plot-pen "EC"
plot usEC

end

to plot-visitors

set-current-plot "Visitors by type"
set-current-plot-pen "TSI"
plot nTSI 
set-current-plot-pen "SPT"
plot nSPT
set-current-plot-pen "SAX"
plot nSAX
set-current-plot-pen "SAW"
plot nSAW  
set-current-plot-pen "CCP"
plot nCCP
set-current-plot-pen "CCW"
plot nCCW
set-current-plot-pen "ID"
plot nID
set-current-plot-pen "EC"
plot nEC
set-current-plot-pen "TOT"
plot nvisitors
end

to plot-CUMvisitors

set-current-plot "Cumulated Visitors by type"
set-current-plot-pen "TSI"
plot CnTSI 
set-current-plot-pen "SPT"
plot CnSPT
set-current-plot-pen "SAX"
plot CnSAX
set-current-plot-pen "SAW"
plot CnSAW  
set-current-plot-pen "CCP"
plot CnCCP
set-current-plot-pen "CCW"
plot CnCCW
set-current-plot-pen "ID"
plot CnID
set-current-plot-pen "EC"
plot CnEC

end


to plot-arrivals
set-current-plot "Tourist Nights - Arrivals"
set-current-plot-pen "T. Nights"
plot novernightvisitors 
set-current-plot-pen "Arrivals"
plot arrivals
set-current-plot-pen "Visitors"
plot Cnvisitors
end  

to plot-balances

set-current-plot "Balances $"
set-current-plot-pen "Accom"
plot [balance] of one-of meas with [category = "accomodations"]
set-current-plot-pen "Restaur"
plot [balance] of one-of meas with [category = "restaurants"]
set-current-plot-pen "Retail"
plot [balance] of one-of meas with [category = "retailers"]
set-current-plot-pen "Other"
plot [balance] of  one-of meas with [category = "otherfacilities"]  
set-current-plot-pen "DownHill"
plot [balance] of one-of meas with [category = "downhills"]
set-current-plot-pen "XCountry"
plot [balance] of one-of meas with [category = "xcountries"]

if any? offpistes [
set-current-plot-pen "OffPiste"
plot [balance] of one-of meas with [category = "offpistes"]]  

if any? snowparks [
  set-current-plot-pen "SPark"
plot [balance] of one-of meas with [category = "snowparks"]]
end

to plot-occupation

set-current-plot "Occupation rate"
set-current-plot-pen "Accom"
plot mean [occupation-rate] of accomodations
set-current-plot-pen "Restaur"
plot mean [occupation-rate] of restaurants
set-current-plot-pen "Other"
plot mean [occupation-rate] of otherfacilities  
set-current-plot-pen "DownHill"
plot mean [occupation-rate] of down_hills
set-current-plot-pen "XCountry"
plot mean [occupation-rate] of xcountries

if any? offpistes [
set-current-plot-pen "OffPiste"
plot mean [occupation-rate] of offpistes]  

if any? snowparks [
  set-current-plot-pen "SPark"
plot mean [occupation-rate] of snowparks]

set-current-plot "Transfers of tourist agents (in km)"
;set-current-plot-pen "Cumulative"
;plot 
set-current-plot-pen "Daily"
plot dailytransfer

end

to checkDestinationParameters
  
 let a count patches with [luse = 3]
 let b count patches with [luse = 2]
 set nature-ratio (a / b) 
 
 set km-downhill (sum [kmtracks] of down_hills)
 set km-offpiste (sum [kmtracks] of offpistes with [nlifts = 0])
 set km-xcountry (sum [kmtracks] of xcountries)  
 set km-freeride (sum [kmtracks] of offpistes with [nlifts > 0])  

 set tricks-sp sum [ntricks] of snowparks  

 set nothersport count otherfacilities with [category = "other-sports"]
 set cc-othersport sum [ccc] of otherfacilities with [category = "other-sports"]
 set nwellness count otherfacilities with [category = "wellness"]
 set cc-wellness sum [ccc] of otherfacilities with [category = "wellness"]
 set nqualityhotels count accomodations with [category = "three-four-stars"]
 set beds-qualityhotels sum [nbeds] of accomodations with [category = "three-four-stars"]
 let o count retailers
 let p count retailers with [category = "clothes"]
 set boutique-ratio (p / o) 

 set nkindergarten count otherfacilities with [category = "kindergarten"]
 set cc-kindergarten sum [ccc] of otherfacilities with [category = "kindergarten"]
 
 set h (count retailers with [category = "bars" and myzone = 5])
 set i (count retailers with [category = "bars" and myzone = 8])
 
 set kmartsnowDH sum [kmtracks * AS] of down_hills  
 set kmartsnowXC sum [kmtracks * AS] of xcountries  
 set KmartsnowSP sum [km2 * AS] of SnowParks 
 
 end

to plot-labour

set-current-plot "Human Labour $"
set-current-plot-pen "Accom"
plot [hlabour] of one-of meas with [category = "accomodations"]
set-current-plot-pen "Restaur"
plot [hlabour] of one-of meas with [category = "restaurants"]
set-current-plot-pen "Retail"
plot [hlabour] of one-of meas with [category = "retailers"]
set-current-plot-pen "Other"
plot [hlabour] of  one-of meas with [category = "otherfacilities"]  
set-current-plot-pen "DownHill"
plot [hlabour] of one-of meas with [category = "downhills"]
set-current-plot-pen "XCountry"
plot [hlabour] of one-of meas with [category = "xcountries"]

if any? offpistes [
set-current-plot-pen "OffPiste"
plot [hlabour] of one-of meas with [category = "offpistes"]]  

if any? snowparks [
set-current-plot-pen "SPark"
plot [hlabour] of one-of meas with [category = "snowparks"]]
end

to plot-ArtSnow
set-current-plot "Artificial Snow $"
set-current-plot-pen "DH high"
plot sum [cumartsnowcost] of down_hills with [myzone = 7 or myzone = 8 or myzone = 10]
set-current-plot-pen "DH low"
plot sum [cumartsnowcost] of down_hills with [myzone = 5 or myzone = 9]
set-current-plot-pen "XC high"
plot [cumartsnowcost] of one-of xcountries with [myzone = 11]
set-current-plot-pen "XC low"
plot [cumartsnowcost] of one-of xcountries with [myzone = 6]

if any? snowparks with [myzone = 8] [
set-current-plot-pen "SP high"
plot [cumartsnowcost] of one-of snowparks with [myzone = 8]] 

if any? snowparks with [myzone = 5] [
set-current-plot-pen "SP low"
plot [cumartsnowcost] of one-of snowparks with [myzone = 5]]  

set-current-plot-pen "TOT"
plot totcumartsnowcost
end

to plot-ArtSnowDay
set-current-plot "Artificial Snow / Days"
set-current-plot-pen "DH high"
plot mean [ArtSnowDay] of down_hills with [myzone = 7 or myzone = 8 or myzone = 10]
set-current-plot-pen "DH low"
plot mean [ArtSnowDay] of down_hills with [myzone = 5 or myzone = 9]
set-current-plot-pen "XC high"
plot [ArtSnowDay] of one-of xcountries with [myzone = 11]
set-current-plot-pen "XC low"
plot [ArtSnowDay] of one-of xcountries with [myzone = 6]

if any? snowparks with [myzone = 8] [
set-current-plot-pen "SP high"
plot [ArtSnowDay] of one-of snowparks with [myzone = 8]] 

if any? snowparks with [myzone = 5] [
set-current-plot-pen "SP low"
plot [ArtSnowDay] of one-of snowparks with [myzone = 5]]  
end

to plot-energy

set-current-plot "Energy $"
set-current-plot-pen "Accom"
plot [energy] of one-of meas with [category = "accomodations"]
set-current-plot-pen "Restaur"
plot [energy] of one-of meas with [category = "restaurants"]
set-current-plot-pen "Retail"
plot [energy] of one-of meas with [category = "retailers"]
set-current-plot-pen "Other"
plot [energy] of  one-of meas with [category = "otherfacilities"]  
set-current-plot-pen "DownHill"
plot [energy] of one-of meas with [category = "downhills"]
set-current-plot-pen "XCountry"
plot [energy] of one-of meas with [category = "xcountries"]

if any? offpistes [
set-current-plot-pen "OffPiste"
plot [energy] of one-of meas with [category = "offpistes"]]  

if any? snowparks [
set-current-plot-pen "SPark"
plot [energy] of one-of meas with [category = "snowparks"]]
end


to plot-snowcover

set-current-plot "Snow Cover (cm)"
set-current-plot-pen "Max"
plot max [snowcover] of referencepoints
set-current-plot-pen "Mean"
plot mean [snowcover] of referencepoints
set-current-plot-pen "Min"
plot min [snowcover] of referencepoints

end  

to plot-temp

set-current-plot "Temperature (�C)"
set-current-plot-pen "Max"
plot max [temp] of referencepoints
set-current-plot-pen "Mean"
plot mean [temp] of referencepoints
set-current-plot-pen "Min"
plot min [temp] of referencepoints

end  

to plot-snowsecurity
set-current-plot "Avalanche Risk"
plot avdestsnowsecurity
end  

to plot-tickmax
set-current-plot "Max Snow Cover / Day"
plot tickmax
end     


to make-movie
movie-start "AuronzoWinSim.mov"
movie-set-frame-rate 2
setup
while [ticks < 252]
[go
movie-grab-interface]
movie-close  
end   
@#$#@#$#@
GRAPHICS-WINDOW
635
10
1035
275
-1
-1
15.6
1
10
1
1
1
0
0
0
1
0
24
-14
0
0
0
1
ticks
30.0

BUTTON
6
10
61
43
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
6
44
61
77
go_1
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
6
77
61
110
go +
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
105
57
232
102
ClimateScenario
ClimateScenario
"Remo-UBA A1B" "Remo-UBA B1" "Baseline80-00" "Baseline80-00x2"
3

CHOOSER
103
107
233
152
DevelopmentStrategy
DevelopmentStrategy
"BAU" "Ski Intensive" "Alternative Ski" "Beyond Snow"
3

CHOOSER
101
153
235
198
SocietalScenario
SocietalScenario
"Conservative" "Optimistic"
1

CHOOSER
4
115
96
160
layer
layer
"areas" "land use"
0

PLOT
700
1026
985
1203
Unsatisfied Tourists
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"TSI" 1.0 0 -7500403 true "" ""
"SPT" 1.0 0 -2674135 true "" ""
"ID" 1.0 0 -13791810 true "" ""
"EC" 1.0 0 -955883 true "" ""
"SAX" 1.0 0 -8630108 true "" ""
"SAW" 1.0 0 -14835848 true "" ""
"CCW" 1.0 0 -10899396 true "" ""
"CCP" 1.0 0 -1184463 true "" ""

PLOT
3
503
992
679
Visitors by type
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"TSI" 1.0 0 -7500403 true "" ""
"SPT" 1.0 0 -2674135 true "" ""
"ID" 1.0 0 -13791810 true "" ""
"EC" 1.0 0 -955883 true "" ""
"SAX" 1.0 0 -8630108 true "" ""
"SAW" 1.0 0 -14835848 true "" ""
"CCW" 1.0 0 -10899396 true "" ""
"CCP" 1.0 0 -1184463 true "" ""
"TOT" 1.0 0 -16777216 true "" ""

PLOT
534
682
991
856
Balances $
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Accom" 1.0 0 -2674135 true "" ""
"Restaur" 1.0 0 -955883 true "" ""
"Other" 1.0 0 -11221820 true "" ""
"DownHill" 1.0 0 -7500403 true "" ""
"XCountry" 1.0 0 -8630108 true "" ""
"OffPiste" 1.0 0 -10899396 true "" ""
"SPark" 1.0 0 -1184463 true "" ""
"Retail" 1.0 0 -5825686 true "" ""

PLOT
355
1024
694
1204
Occupation Rate
NIL
NIL
0.0
10.0
0.0
1.0
true
true
"" ""
PENS
"Accom" 1.0 0 -2674135 true "" ""
"Restaur" 1.0 0 -955883 true "" ""
"Other" 1.0 0 -11221820 true "" ""
"DownHill" 1.0 0 -7500403 true "" ""
"XCountry" 1.0 0 -8630108 true "" ""
"OffPiste" 1.0 0 -10899396 true "" ""
"SPark" 1.0 0 -1184463 true "" ""

MONITOR
6
165
74
210
Winter  num.
season
17
1
11

MONITOR
6
210
93
255
Period
month
17
1
11

MONITOR
238
10
316
55
KM of DownHill
km-downhill
17
1
11

MONITOR
239
104
325
149
KM of X-Country
km-xcountry
17
1
11

MONITOR
332
55
409
100
KM of OffPiste
km-offpiste
17
1
11

MONITOR
323
10
408
55
KM of FreeRide
km-freeride
17
1
11

MONITOR
352
197
420
242
Nature Ratio
nature-ratio
2
1
11

MONITOR
327
107
430
152
SnowParks' terrains
tricks-sp
17
1
11

MONITOR
269
197
352
242
Boutiques Ratio
boutique-ratio
2
1
11

MONITOR
368
277
440
322
Wellness CC
cc-wellness
17
1
11

MONITOR
268
237
355
282
Kindergarten CC
cc-Kindergarten
17
1
11

MONITOR
356
237
443
282
Other Sports CC
cc-othersport
17
1
11

MONITOR
266
277
370
322
Beds High Standard Hotels
beds-qualityhotels
17
1
11

MONITOR
507
10
581
55
Tourist nights
nOvernightVisitors
17
1
11

MONITOR
430
10
503
55
Total Visitors
CnVisitors
17
1
11

MONITOR
583
10
633
55
NIL
Arrivals
17
1
11

MONITOR
436
132
499
177
TSI Visitors
CnTSI
17
1
11

MONITOR
436
55
502
100
SPT Visitors
CnSPT
17
1
11

MONITOR
501
133
563
178
EC Visitors
CnEC
17
1
11

MONITOR
436
92
494
137
ID Visitors
CnID
17
1
11

MONITOR
562
100
630
145
CCP Visitors
CnCCP
17
1
11

MONITOR
560
56
629
101
CCW Visitors
CnCCW
17
1
11

MONITOR
497
55
562
100
SAX Visitors
CnSAX
17
1
11

MONITOR
496
91
566
136
SAW Visitors
CnSAW
17
1
11

BUTTON
710
275
783
308
NIL
profiler:start
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
783
276
852
309
NIL
profiler:stop
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
907
275
978
308
NIL
profiler:reset
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
852
276
907
309
NIL
output-print profiler:report
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
446
188
520
233
 Auronzo S.C.
[avzonesnowcover] of zones with [myname = 2]
2
1
11

MONITOR
446
226
515
271
Misurina S.C.
[avzonesnowcover] of zones with [myname = 3]
2
1
11

MONITOR
519
188
600
233
Temp. Auronzo 
[maxzonetemp] of zones with [myname = 2]
2
1
11

MONITOR
515
226
595
271
Temp. Misurina
[maxzonetemp] of zones with [myname = 3]
2
1
11

MONITOR
450
272
524
317
Snow Security
avdestSnowSecurity
2
1
11

PLOT
4
858
528
1019
Human Labour $
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Accom" 1.0 0 -2674135 true "" ""
"Restaur" 1.0 0 -955883 true "" ""
"Other" 1.0 0 -11221820 true "" ""
"DownHill" 1.0 0 -7500403 true "" ""
"XCountry" 1.0 0 -8630108 true "" ""
"OffPiste" 1.0 0 -10899396 true "" ""
"SPark" 1.0 0 -1184463 true "" ""
"Retail" 1.0 0 -5825686 true "" ""

PLOT
5
1209
540
1359
Snow Cover (cm)
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Max" 1.0 0 -1184463 true "" ""
"Mean" 1.0 0 -955883 true "" ""
"Min" 1.0 0 -8630108 true "" ""

PLOT
543
1209
986
1359
Temperature (�C)
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Max" 1.0 0 -1184463 true "" ""
"Mean" 1.0 0 -955883 true "" ""
"Min" 1.0 0 -8630108 true "" ""

PLOT
696
1363
985
1519
Avalanche Risk
NIL
NIL
0.0
10.0
0.0
5.0
true
false
"" ""
PENS
"default" 1.0 0 -2674135 true "" ""

PLOT
4
1022
350
1205
Artificial Snow $
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"DH high" 1.0 0 -2674135 true "" ""
"DH low" 1.0 0 -955883 true "" ""
"XC high" 1.0 0 -5825686 true "" ""
"XC low" 1.0 0 -8630108 true "" ""
"SP high" 1.0 0 -13840069 true "" ""
"SP low" 1.0 0 -1184463 true "" ""
"TOT" 1.0 2 -16777216 true "" ""

MONITOR
522
272
602
317
Max Snow Day 
tickmax
17
1
11

PLOT
400
1363
692
1519
Max Snow Cover / Day
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -955883 true "" ""

PLOT
5
1363
395
1522
Artificial Snow / Days
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"DH high" 1.0 0 -2674135 true "" ""
"DH low" 1.0 0 -955883 true "" ""
"XC high" 1.0 0 -5825686 true "" ""
"XC low" 1.0 0 -8630108 true "" ""
"SP high" 1.0 0 -13840069 true "" ""
"SP low" 1.0 0 -1184463 true "" ""

BUTTON
639
275
709
308
NIL
make-movie
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
102
200
235
245
competition
competition
"generic" "niche"
1

PLOT
5
349
552
499
Tourist Nights - Arrivals
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"T. Nights" 1.0 0 -11221820 true "" ""
"Arrivals" 1.0 0 -14835848 true "" ""
"Visitors" 1.0 0 -13345367 true "" ""

MONITOR
238
53
325
98
Art.Snow Km DH
kmartsnowDH
2
1
11

MONITOR
240
148
325
193
Art.Snow KM XC
kmartsnowXC
2
1
11

MONITOR
335
150
430
195
Art. Snow km2 SP
kmartsnowSP
17
1
11

MONITOR
5
258
56
303
users DH
sum [users] of Down_hills
17
1
11

MONITOR
56
258
116
303
users SP
sum [users] of SnowParks
17
1
11

MONITOR
112
258
169
303
users OP
sum [users] of offpistes
17
1
11

MONITOR
4
302
58
347
users XC
sum [users] of Xcountries
17
1
11

MONITOR
58
302
112
347
users OF
sum [users] of otherfacilities
17
1
11

MONITOR
112
302
173
347
users Ret.
sum [users] of retailers
17
1
11

MONITOR
168
258
232
303
users Rest.
sum [users] of Restaurants
17
1
11

MONITOR
173
302
233
347
users Acc.
sum [users] of accomodations
17
1
11

PLOT
3
681
531
856
Daily Expense $
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"TOT" 1.0 0 -16777216 true "" ""
"TSI" 1.0 0 -7500403 true "" ""
"SPT" 1.0 0 -2674135 true "" ""
"ID" 1.0 0 -13791810 true "" ""
"EC" 1.0 0 -955883 true "" ""
"SAX" 1.0 0 -8630108 true "" ""
"SAW" 1.0 0 -14835848 true "" ""
"CCW" 1.0 0 -13840069 true "" ""
"CCP" 1.0 0 -1184463 true "" ""

PLOT
533
860
990
1019
Energy $
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Accom" 1.0 0 -2674135 true "" ""
"Restaur" 1.0 0 -955883 true "" ""
"Other" 1.0 0 -11221820 true "" ""
"DownHill" 1.0 0 -7500403 true "" ""
"XCountry" 1.0 0 -8630108 true "" ""
"OffPiste" 1.0 0 -10899396 true "" ""
"SPark" 1.0 0 -1184463 true "" ""
"Retail" 1.0 0 -5825686 true "" ""

CHOOSER
105
10
232
55
param-settings
param-settings
"calibrated" "gsize-lower" "gsize-higher" "stay-lower" "stay-higher" "pos=0-lower" "pos=0-higher" "km-lower" "km-higher" "snow-lower" "snow-higher" "kidsp-lower" "kidsp-higher" "ssp-lower" "ssp-higher" "comp-lower" "comp-higher" "nature-lower" "nature-higher" "gn-kx-nx-clow" "gn-kn-nx-clow" "gn-kx-nn-clow" "gn-kx-nx-chigh" "gn-kn-nn-clow" "gn-kn-nx-chigh" "gn-kx-nn-chigh" "gn-kn-nn-chigh" "gx-kx-nx-clow" "gx-kn-nx-clow" "gx-kx-nn-clow" "gx-kx-nx-chigh" "gx-kn-nn-clow" "gx-kn-nx-chigh" "gx-kx-nn-chigh" "gx-kn-nn-chigh"
0

PLOT
560
333
990
500
Cumulated Visitors by type
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"TSI" 1.0 0 -7500403 true "" ""
"SPT" 1.0 0 -2674135 true "" ""
"ID" 1.0 0 -13791810 true "" ""
"EC" 1.0 0 -955883 true "" ""
"SAX" 1.0 0 -8630108 true "" ""
"SAW" 1.0 0 -14835848 true "" ""
"CCW" 1.0 0 -10899396 true "" ""
"CCP" 1.0 0 -1184463 true "" ""

SLIDER
64
10
97
102
run-num
run-num
1
30
1
1
1
NIL
VERTICAL

MONITOR
388
686
484
731
NIL
cumavexpense
2
1
11

MONITOR
36
525
111
570
NIL
mean-gsize
3
1
11

PLOT
7
1525
987
1675
Transfers of tourist agents (in km)
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Cumulative" 1.0 0 -16777216 false "" ""
"Daily" 1.0 0 -2674135 true "" ""

@#$#@#$#@
## WHAT IS IT?

This section could give a general understanding of what the model is trying to show or explain.

## HOW IT WORKS

This section could explain what rules the agents use to create the overall behavior of the model.

## HOW TO USE IT

This section could explain how to use the model, including a description of each of the items in the interface tab.

## THINGS TO NOTICE

This section could give some ideas of things for the user to notice while running the model.

## THINGS TO TRY

This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.

## EXTENDING THE MODEL

This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.

## NETLOGO FEATURES

This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.

## RELATED MODELS

This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.

## CREDITS AND REFERENCES

This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
